/*
   Questo programma fa parte del Corso di C
   Copyright (C) 1990 Gruppo Editoriale Jackson
   Copyright (C) 2002 Enrico Colombini
   Tutti i diritti riservati
*/


/* ACCENTI: filtro per convertire lettere accentate in combinazioni ASCII */


#include <stdio.h>
#include <string.h>
#include <ctype.h>


/********************************************************************
 * main
 ********************************************************************/

main()
{
    char speciale[] = "";     /*lettere accentate del PC IBM <1>*/
    char normale[]  = "aaeeiioouu";     /*corrispondenti non accentate*/
    char accento[]  = "`'`'`'`'`'";     /*accenti da usare*/
    char *p;                            /*<2>*/
    int  n;
    int  c;

    fprintf(stderr,
        "\n Conversione di lettere accentate in combinazioni ASCII\n"
        " (se usato da tastiera, per uscire premere F6 e poi Return).\n\n");

    while ( (! feof(stdin)) && (! ferror(stdin))    /*scandisce file <3>*/
           && (! ferror(stdout)) ) {
        c = getchar();                              /*legge carattere <4>*/
        if ( (p = strchr(speciale,c)) != NULL) {    /*se speciale <5>*/
            n = p-speciale;                         /*trova posizione <6>*/
            putchar(normale[n]);                    /*converte <7>*/
            c = getchar();                          /*legge successivo <8>*/
            if ( (! isalnum(c)) && c < 128) {       /*accenta se ultimo <9>*/
                putchar(accento[n]);
            }
            ungetc(c,stdin);                        /*rimette a posto <10>*/
        } else {                                    /*se normale, lo stampa*/
            putchar(c);
        }
    }

    if (ferror(stdin)) {                            /*se errore <11>*/
        fprintf(stderr,                             /*lo segnala*/
            "- Conversione interrotta per un errore di lettura.\a\n");
    } else if (ferror(stdout)) {
        fprintf(stderr,
            "- Conversione interrotta per un errore di scrittura.\a\n");
    }
}

/* Note su main:
    <1>  Per ogni lettera speciale contenuta nella stringa (array di char)
         speciale[], il corrispondente carattere di normale[] contiene la
         lettera non accentata da usare in sostituzione, ed il corrispondente
         carattere di accento[] contiene l'adatto accento da scrivere dopo
         la lettera. Sono considerate solo le vocali accentate in uso nella
         lingua italiana.
    <2>  p  un pointer a char, e pu ad esempio puntare ad un carattere di
         una stringa.
    <3>  Il ciclo termina quando il file di input (stdin) termina, oppure
         se si verifica un errore di lettura dal file di input (stdin) o di
         scrittura sul file di output (stdout). Questo ovviamente non avviene
         se input ed output non sono ridiretti, cio se si usano tastiera e
         video. Se per il programma viene usato (ad esempio) per convertire
         da un file a un altro (es. ACCENTI <TESTO.IBM >TESTO.ASC), possono
         verificarsi errori di lettura o scrittura dei file (es. disco pieno)
         e bisogna quindi tenere conto di queste possibilit.
    <4>  Una getchar legge da stdin, cio equivale a fgetc(stdin), senza
         sapere se stdin  la tastiera o  ridiretto ed  in realt un file.
    <5>  La strchr ritorna un pointer alla posizione di c nella stringa
         speciale[], oppure NULL se non lo trova. Il pointer viene assegnato
         alla variabile p prima di controllare se  NULL. L'assegnazione nel
         confronto  una costruzione tipica del C.
    <6>  Dato che p  un pointer (ritornato da strchr) ad un carattere della
         stringa speciale[], cio l'indirizzo del carattere trovato,  valido
         calcolare la differenza tra p ed un altro pointer alla stessa
         stringa, come l'indirizzo del primo carattere della stringa, cio
         &speciale[0] o, pi brevemente, speciale. In sostanza, p-speciale
          la posizione in speciale[] del carattere c trovato da strchr. Non
         sarebbe invece valido fare operazioni tra p ed un pointer ad una
         delle altre stringhe, es. accento.
    <7>  Una volta calcolata la posizione n, pu essere usata come indice per
         leggere il corrispondente carattere in un'altra stringa. Ricordiamo
         che normale[n] equivale a *(normale+n), vedi lezione B7. Questa
         istruzione stampa dunque il carattere normale corrispondente a
         quello accentato (c).
    <8>  Il programma stampa un accento dopo il carattere solo se questo 
         a fine parola, cio non  seguito da un carattere alfanumerico. Per
         saperlo bisogna per leggere il carattere successivo: questo sar
         poi 'rimesso nel file' con la ungetc in modo che al ciclo successivo
         possa essere letto regolarmente.
    <9>  La isalnum  definita per i caratteri ASCII, cio con codice da 0
         a 127. Per essere certi che non vi siano problemi, scartiamo i
         caratteri con codice superiore a 127, cio 128..255. Come gi detto,
         questo programma funziona solo con le parole italiane.
    <10> La ungetc rimette il carattere c nel file stdin, cio in pratica
         torna indietro di un carattere nella lettura del file. Non si
         possono fare due ungetc di seguito, cio non si pu tornare indietro
         di due caratteri, ma di solito una  sufficiente. In questo caso, il
         programma ne risulta notevolmente semplificato e pi leggibile.
         (senza ungetc sarebbe stata necessaria un'altra variabile, da
         consultare durante il ciclo per sapere se era rimasto qualcosa in
         sospeso dal ciclo precedente).
    <11> Per quanto improbabili, gli errori non vanno mai trascurati. Come
         minimo ci vuole un messaggio di avvertimento che informi l'utente
         che qualcosa non ha funzionato, e quindi il file prodotto dal
         programma non  valido o  comunque incompleto. Stampando su stderr
         si  sicuri che il messaggio finisca su video (stdout pu essere
         stato ridiretto su un file).
*/
