/*
   Questo programma fa parte del Corso di C
   Copyright (C) 1990 Gruppo Editoriale Jackson
   Copyright (C) 2002 Enrico Colombini
   Tutti i diritti riservati
*/


/* ALLINEA: stampe formattate di numeri con printf */


#include <stdio.h>

main()
{
    int x = 127;    /*numero da stampare*/

    printf("\n  Allineamenti di numeri con printf:\n\n");

    printf("Stampa normalmente:                   *%d*\n\n",x);     /*<1>*/

    printf("Allinea a destra in campo largo 8:    *%8d*\n",x);      /*<2a>*/
    printf("Allinea a sinistra in campo largo 8:  *%-8d*\n\n",x);   /*<2b>*/

    printf("Stampa in campo troppo stretto (2):   *%2d*\n",x);      /*<3>*/
    printf("Stampa in campo largo 6, con zeri:    *%06d*\n",x);     /*<4a>*/
    printf("Stampa un minimo di 6 cifre:          *%.6d*\n\n",x);   /*<4b>*/

    printf("Stampa un numero negativo:            *%d*\n\n",-x);    /*<5>*/

    printf("Segno su numero positivo:             *%+d*\n",x);      /*<6a>*/
    printf("Segno su numero negativo:             *%+d*\n\n",-x);   /*<6b>*/

    printf("Spazio su numero positivo:            *% d*\n",x);      /*<7a>*/
    printf("Spazio su numero negativo:            *% d*\n",-x);     /*<7b>*/
}

/* Note:
   <1>  I due asterischi non fanno parte della specifica di stampa, ma sono
        normali caratteri aggiunti per evidenziare inizio e fine della
        stampa del numero.
        Una semplice %d non aggiunge spazi n prima n dopo il numero,
        quindi gli asterischi vengono stampati adiacenti al numero stesso.
   <2a> Indicando la larghezza del campo (%8d) il numero  allineato a destra
        (con spazi sulla sinistra) se non riempie interamente il campo.
   <2b> Mettendo un meno tra % e larghezza del campo, il numero viene invece
        allineato a sinistra (con spazi sulla destra).
   <3>  Se il numero supera la larghezza del campo, viene comunque stampato
        per intero. In questo caso sono richieste 2 cifre, ma ne stampa 3.
   <4a> Volendo riempire con zeri gli eventuali spazi eccedenti prima
        del numero, basta iniziare la larghezza del campo con uno zero.
   <4b> Se non  indicata una larghezza, il numero minimo di cifre ha lo
        stesso effetto che richiedere gli zeri iniziali (vedi 4a).
        cifre, con un punto prima della larghezza del campo.
   <5>  Un numero negativo viene naturalmente stampato col segno meno.
   <6a> Per avere il segno + davanti ai numeri positivi, si indica un +
        subito dopo il %.
   <6b> Ovviamente il + non cambia il segno meno dei numeri negativi.
   <7a> Uno spazio dopo il % lascia uno spazio davanti ai numeri positivi.
   <7b> Mentre non altera il meno davanti ai negativi (come in GW-BASIC).
*/
