/*
   Questo programma fa parte del Corso di C
   Copyright (C) 1990 Gruppo Editoriale Jackson
   Copyright (C) 2002 Enrico Colombini
   Tutti i diritti riservati
*/


/* INPCON: input controllato di numeri e stringhe */


#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include "Jconio.c"


/* prototipi funzioni: */

int InputStringa(char *prompt, char *s, int lmax, int col, int back);
int InputInt(char *prompt, int n, int mi, int ma, int col, int back);


#define MAXRIV 12         /*lunghezza massima nome rivista*/
#define MINNUM 6          /*valore minimo e massimo numeri*/
#define MAXNUM 48
#define POSNUM 30         /*posizione input numeri*/

#define INCOL  BLACK      /*colori per input <1>*/
#define INBACK LIGHTGRAY


main()
{
    char riv[MAXRIV+1];     /*<2>*/
    int  num;
    char s[81];

    Jcursor(0);                                        /*spegne cursore*/
    Jputs("\r\n Input controllato:\r\n\r\n");

    strcpy(riv,"Bit");                                 /*default <3>*/
    InputStringa("Rivista: ",riv,MAXRIV,INCOL,INBACK); /*input <4>*/

    sprintf(s,"Numeri (%d..%d): ",MINNUM,MAXNUM);      /*prepara prompt <5>*/
    Jgotoxy(POSNUM,Jposy());                           /*si posiziona <6>*/
    num = InputInt(s,12,MINNUM,MAXNUM,INCOL,INBACK);   /*input*/

    Jputs("\r\n\r\n");                                 /*due a capo*/
    sprintf(s,"%d numeri di \"%s\" sono un buon "      /*prepara risposta*/
              "investimento.\r\n",num,riv);
    Jputs(s);                                          /*e la stampa*/

    Jcursor(1);                                        /*riaccende cursore*/
}

/* Note su main:
    <1> Con questi colori, l'input appare in inverse (nero su bianco).
    <2> Spazio per il nome della rivista, pi lo zero finale. Come al solito
         bene non usare numeri, ma costanti definite all'inizio.
    <3> La InputStringa mostra come default il contenuto corrente della
        stringa in cui viene effettuato l'input, cio riv[].
    <4> Non  considerato il caso in cui l'utente introduca una stringa
        nulla. Si potrebbe tenerne conto modificando la InputStringa per
        specificare anche un numero minimo di caratteri, oppure ripetendo
        l'input se la stringa  nulla (come fa la InputInt).
    <5> La stringa di prompt verr poi passata alla InputInt.
    <6> In questo modo ci si sposta solo in orizzontale (x), mantenendosi
        sulla riga (y) corrente.
*/


/********************************************************************
 * InputStringa: mostra campo di input con default usando colori col
 *               e back, input controllato di stringa nell'array s[]
 *               non oltre lmax caratteri, accetta correzioni con
 *               backspace, mette zero finale, ritorna lunghezza della
 *               stringa introdotta.
 ********************************************************************/

int InputStringa(char *prompt, char *s, int lmax, int col, int back)  /*<1>*/
{
    enum { BS = 8, BACK = 1075 };      /*codici tasti <2>*/

    char buf[81];       /*buffer di linea*/
    int  ls;            /*lunghezza stringa*/
    int  px,py,pxi;     /*posizione originaria e di input*/
    int  cf,cb;         /*colori originari*/
    int  i,c,ok;

    px = Jposx();                                   /*registra posizione <3>*/
    py = Jposy();
    cf = Jgettextcolor();                           /*e colori*/
    cb = Jgettextback();

    Jputs(prompt);                                  /*stampa prompt*/
    pxi = Jposx();                                  /*posizione di input*/

    Jtextcolor(col);                                /*mette colori di input*/
    Jtextback(back);
    Jputs(s);                                       /*mostra default*/
    ls = strlen(s);                                 /*lunghezza corrente*/
    for (i = ls; i < lmax; i++) {                   /*evidenzia campo <4>*/
        Jputch(' ');
    }
    Jgotoxy(pxi+ls,py);                             /*torna a fine default*/

    s += ls;                                        /*punta alla fine <5>*/
    Jclrkey();                                      /*cancella buffer <6>*/
    do {
        c = Jgetkey(1);
        ok = (c == '\r');
        if ( (c == BS || c == BACK) && ls > 0) {    /*indietro <7>*/
            ls--;
            s--;
            Jgotoxy(pxi+ls,py);
            Jputch(' ');
            Jgotoxy(pxi+ls,py);
        } else if (isprint(c) && ls < lmax) {       /*carattere valido <8>*/
            *s++ = c;
            ls++;
            Jputch(c);
        } else if (! ok) {                          /*tasto non valido*/
            Jputch('\a');
        }
    } while (! ok);

    *s = 0;                                         /*termina stringa <9>*/
    Jgotoxy(px,py);                                 /*torna dov'era <10>*/
    Jtextcolor(cf); Jtextback(cb);                  /*risistema colori*/

    return ls;                                      /*ritorna lunghezza*/
}

/* Note su InputStringa:
    <1>  Il contenuto corrente della stringa s[] verr proposto come default.
    <2>  La enum va benissimo per definire costanti intere locali ad una
         funzione.
    <3>  Una funzione non deve alterare senza motivo le caratteristiche
         correnti di stampa, in particolare la posizione ed i colori.
    <4>  Il campo di input viene evidenziato riempiendolo di spazi con i
         colori di input. Se il background di input  uguale a quello normale,
         il campo non risulter evidenziato rispetto al video.
    <5>  la stringa s passata come argomento  in realt un pointer locale,
         che punta all'inizio della stringa indicata nella chiamata (in
         questo caso, la riv[] del main). Aggiungendo la lunghezza del
         contenuto attuale (il default), s punta allo zero finale della
         stringa stessa. Scrivendo un carattere a *s, lo si scrive quindi di
         seguito a quelli gi presenti nella stringa.
    <6>  Per evitare che caratteri battuti in precedenza (in particolare un
         Return) possano alterare l'input,  bene cancellare eventuali tasti
         presenti nel buffer di tastiera ed in attesa di essere letti.
    <7>  In caso di backspace o freccia indietro, torna indietro di un
         carattere nella stringa (s--), decrementa il contatore di posizione
         (ls--), e cancella un carattere dal video scrivendovi sopra uno
         spazio.
    <8>  Se il carattere  valido lo aggiunge alla stringa incrementando il
         pointer di lavoro (s++), incrementa anche il contatore di posizione
         (ls++) e stampa il carattere sul video (echo). Il test di carattere
         valido  abbastanza permissivo (isprint), e potrebbe essere
         sostituito da test pi specifici. In particolare, si potrebbe
         passare come ulteriore argomento una stringa contenente i caratteri
         validi ammessi nell'input.
    <9>  s punta al primo carattere successivo a quelli introdotti, cio
         proprio al posto adatto per lo zero finale. Notare che oltre questo
         zero possono esserci dei caratteri (residuo di cancellazioni con
         backspace), che non danno comunque alcun fastidio.
    <10> Tutto ritorna com'era prima della chiamata. Questo consente di
         chiamare ripetutamente la InputStringa senza preoccuparsi di
         riposizionare il cursore e ristabilire i colori correnti (che
         potrebbero non essere noti al chiamante), come fa ad esempio la
         InputInt.
*/


/********************************************************************
 * InputInt: Input controllato di un intero. Come InputStringa, ma
 *           ritorna un valore compreso tra mi e ma, con default n.
 ********************************************************************/

int InputInt(char *prompt, int n, int mi, int ma, int col, int back)  /*<1>*/
{
    enum { LBUF = 6 };      /*<2>*/

    char buf[LBUF+1];

    sprintf(buf,"%d",n);                                  /*prepara default*/
    while (! (InputStringa(prompt,buf,LBUF,col,back) > 0  /*<3>*/
              && (isdigit(*buf) || *buf == '-')
              && (n = atoi(buf)) >= mi
              && n <= ma)) {
        Jputch('\a');
    }

    return n;                                             /*valore numero*/
}

/* Note su InputInt:
    <1> n contiene il valore da usare come default.
    <2> Nel PC IBM un intero non pu occupare pi di 6 caratteri, dato che
        varia tra -32768 e +32767 (il segno occupa un carattere). In questo
        modo la larghezza del campo di input  fissata a 6 caratteri; si
        potrebbe specificarla con un parametro o, meglio, renderla automatica
        stampando in una stringa (con sprintf) i valori minimo e massimo
        ammessi, ed misurando (con strlen) quale occupi pi spazio.
    <3> Costruzioni di questo genere sono tipiche del C: ripete il ciclo
        finch la stringa introdotta non  nulla e (&&) il primo carattere
         valido (numero o segno meno) e (&&) il numero che questa stringa
        rappresenta (atoi)  maggiore o uguale al minimo e (&&) minore o
        uguale al massimo. Facendo tutto il lavoro nel test si evitano
        una variabile extra ed un altro test, ma occorre fare molta
        attenzione alla leggibilit, specialmente in funzioni complesse.
*/
