/*
   Questo programma fa parte del Corso di C
   Copyright (C) 1990 Gruppo Editoriale Jackson
   Copyright (C) 2002 Enrico Colombini
   Tutti i diritti riservati
*/


/* TASTI: mostra i codici dei tasti con Jgetkey() e getch() */


#include <stdio.h>      /*<1>*/
#include "Jconio.c"


#define F10  1068       /*<2>*/


main()
{
    int  c;
    char buf[80];       /*<3>*/

    Jcursor(0);                                     /*spegne cursore <4>*/
    Jputs("\r\n Codici dei tasti:\r\n\r\n");        /*<5>*/

    do {
        Jputs("Premi un tasto (F10 per smettere): ");
        c = Jgetkey(1);                             /*<6>*/
        if (c < 1000 && c != F10) {                 /*<7>*/
            sprintf(buf,"  getch: %-3d     Jgetkey: %d\r\n",c,c);
        } else {
            sprintf(buf,"  getch: 0,%-3d   Jgetkey: %d\r\n",c-1000,c);
        }
        Jputs(buf);
    } while (c != F10);

    Jcursor(1);                                     /*riaccende cursore <8>*/
}

/* Note:
    <1> Per quanto input ed output siano effettuati usando esclusivamente la
        libreria di console Jackson, la sprintf richiede lo header <stdio.h>.
    <2> Per comodit di lettura in decimale, la Jgetkey ritorna per i tasti
        speciali un codice ottenuto aggiungendo 1000 al codice di scansione.
    <3> Non essendoci una Jprintf, si deve stampare in una stringa con la
        sprintf, e poi stampare la stringa con Jputs. La stringa lavora
        quindi da memoria temporanea di accumulo, o buffer.
    <4> Il cursore serve solo durante l'input. E' quindi una buona idea
        nasconderlo all'inizio del programma. La sua presenza segnaler
        all'utente che  richiesto un suo intervento.
    <5> Per andare a capo con le funzioni delle librerie di console non
        basta un newline (\n), ma  bene indicare esplicitamente un CRLF
        (\r\n), come se si trattasse di un file binario.
    <6> Avendo indicato 1 come parametro, la Jgetkey mostra il cursore
        mentre rimane in attesa di un tasto, e poi lo nasconde nuovamente.
    <7> I codici maggiori di 1000 corrispondono (per la Jgetkey) ai tasti
        speciali. Togliendo 1000 si riottiene il codice di scansione. La
        getch avrebbe invece ritornato due caratteri consecutivi, il primo
        pari a 0 ed il secondo pari al codice di scansione del tasto premuto.
        Per i tasti normali non c' differenza: sia la Jgetkey che la getch
        ritornano semplicemente il codice del carattere corrispondente.
    <8> Al termine del programma ci si deve ricordare di mostrare nuovamente
        il cursore, altrimenti questo rimane invisibile anche nella linea di
        comando del DOS.
*/
