/*
   Questo programma fa parte del Corso di C
   Copyright (C) 1990 Gruppo Editoriale Jackson
   Copyright (C) 2002 Enrico Colombini
   Tutti i diritti riservati
*/


/* SECGRADO: risolve le equazioni di secondo grado (soluzioni reali) */


#include <stdio.h>
#include <math.h>       /*<1>*/

main()
{
    double a,b,c;       /*coefficienti <2>*/
    double d;           /*discriminante*/
    double rd;          /*e sua radice quadrata*/
    double x1,x2;       /*soluzioni*/
    int    n;           /*numero di dati introdotti*/

    printf("\nQuesto programma risolve equazioni di secondo grado"
           " del tipo:\n\nA * X^2 + B * X + C = 0\n\n"
           "dati i valori dei coefficienti A, B, C.\n\n");

    a = b = c = 0.0;                                /*default: zero*/
    printf("A, B, C = ");                           /*prompt*/
    n = scanf("%lf,%lf,%lf",&a,&b,&c);              /*input coefficienti <3>*/
    printf("\n");                                   /*gi di una linea*/

    if (n < 3) {                                    /*mancano dei dati*/
        printf("- Devi introdurre i tre valori"
               " per A,B,C separati da virgole.\n");
    } else if (a == 0.0 && b == 0.0) {              /*a,b=0: non valida <4>*/

        printf("%f = 0 non  un'equazione valida!\n",c);

    } else if (a == 0.0) {                          /*a=0: primo grado*/

        x1 = -c/b;                                  /*calcola soluzione*/
        printf("L'equazione si riduce al primo grado:"
               "  B * X + C = 0\n"
               "C' quindi una sola soluzione:\n\n"
               "X = -C / B = %f\n",x1);

    } else {                                        /*secondo grado*/

        printf("Per prima cosa, calcolo il discriminante D:\n\n");
        d = b*b-4*a*c;                              /*calcola discriminante*/
        printf(" D = B^2 - 4 * A * C = %f\n\n",d);

        /* tre possibili casi, in base al discriminante */

        if (d < 0.0) {                              /*d<0: sol. immaginarie*/

            printf("Il discriminante e' negativo,"
                   " non ci sono soluzioni reali.\n");

        } else if (d == 0.0) {                      /*d=0: sol. coincidenti*/

            x1 = (-b)/(2*a);                        /*calcola soluzione*/
            printf("Il discriminante e' nullo, ci"
                   " sono due soluzioni coincidenti:\n\n"
                   "X1 = X2 = -B / (2 * A) = %f\n",x1);

        } else {                                    /*d>0: due soluz. reali*/

            rd = sqrt(d);                           /*radice di d <5>*/
            x1 = (-b+rd)/(2*a);                     /*calcola soluzioni*/
            x2=(-b-rd)/(2*a);
            printf("Il discriminante e' positivo, ci"
                   " sono due soluzioni distinte:\n\n"
                   " X1 = (-B + SQRT(D)) / (2 * A) = %f\n"
                   " X2 = (-B - SQRT(D)) / (2 * A) = %f\n",x1,x2);

        }                                           /*fine d>0 <6>*/
    }                                               /*fine sec. grado*/
}

/*  Note:
    <1> Poich  usata la funzione sqrt,  essenziale ricordarsi di
        includere il corrispondente header <math.h>.
    <2> Tutte le variabili sono di tipo double, in modo da poter accogliere
        la pi ampia gamma di valori ed effettuare calcoli molto precisi.
    <3> Per effettuare l'input di un double con la scanf si deve indicare
        %lf. Per ciascun %lf contenuto nella stringa di formato deve
        poi essere passato l'indirizzo di una variabile di tipo double.
        Come in SECONDI,  il caso di controllare che tutti i valori siano
        stati effettivamente introdotti in modo corretto, verificando che
        il valore ritornato da scanf coincida col numero di dati richiesti.
    <4> In un programma ben fatto, occorre tenere presenti tutte le
        possibili situazioni. Senza questi controlli, un valore zero per A
        causerebbe un'indesiderabile divisione per zero poco pi avanti.
        Lavorando con numeri reali  bene indicare 0.0 e non 0. Si evitano
        cos possibili problemi in situazioni potenzialmente ambigue.
    <5> Ancora una volta, il valore di d viene passato alla funzione sqrt
        solo se positivo (un numero negativo non ha una radice quadrata
        reale). sqrt ritorna un double, non un int, ed  essendiale per
        evitare errori che sia incluso <math.h> all'inizio del programma.
    <6> Per leggibilit, nel caso di funzioni abbastanza lunghe  utile
        commentare una graffa chiusa per sapere quale blocco termina. Ancor
        meglio sarebbe evitare le funzioni lunghe, e vedremo in seguito
        come lo si possa fare suddividendole in pi funzioni brevi e
        pi facilmente comprensibili.
*/