/*
   Questo programma fa parte del Corso di C
   Copyright (C) 1990 Gruppo Editoriale Jackson
   Copyright (C) 2002 Enrico Colombini
   Tutti i diritti riservati
*/


/* CRIPTO: crittografa/decrittografa una frase */


#include <stdio.h>

#define CODMIN  -25     /*valori minimo e massimo per il codice <1>*/
#define CODMAX  25

main()
{
    int cod = 0;    /*codice, con default per input non valido <2>*/
    int c;          /*carattere corrente*/
    int finito;     /*flag di fine lavoro <3>*/

    printf("\n Crittografia/decrittografia:\n");

    do {

        do {
            printf("\nCodice (da %d a %d, negativo decrittografa, 0 esce): ",
                   CODMIN,CODMAX);
            scanf("%d",&cod);                       /*input codice*/
        } while (cod < CODMIN || cod > CODMAX);     /*lo controlla <4>*/

        while (getchar() != '\n')                   /*ripulisce <5>*/
            ;

        finito = (cod == 0);                        /*esce con zero <6>*/
        if (! finito) {                             /*se ok, lavora <7>*/
            printf( (cod > 0) ?
                   "\nFrase da crittografare: " :
                   "\nFrase da decrittografare: "); /*<8>*/
            while ( (c = getchar()) != '\n') {      /*scandisce frase <9>*/
                if (c >= 'A' && c <= 'Z') {         /*va in minuscolo <10>*/
                    c += ('a'-'A');
                }
                if (c >= 'a' && c <= 'z') {         /*cambia lettere*/
                    c += cod;                       /*con codice*/
                    if (c < 'a')  c += 26;          /*<11>*/
                    if (c > 'z')  c -= 26;
                }
                putchar(c);                         /*stampa carattere*/
            }
            putchar('\n');                          /*a capo*/
        }

    } while (! finito);                             /*esce con codice 0*/

}

/*  Note:
    <1>  La crittografia  di tipo molto semplice: ogni lettera viene
         spostata avanti o indietro del numero di posti indicato dal codice.
         I simboli e le lettere non ASCII (es. ) restano inalterati.
    <2>  Lo 0 di default rimane se la scanf non trova un numero valido alla
         prima esecuzione del programma (in eventuali esecuzioni successive
         rimene l'ultimo numero valido introdotto).
    <3>  Un flag  una variabile logica, che pu essere solamente vera o
         falsa. In C si usa un int, con la convenzione che zero significa
         falso ed ogni altro valore significa vero.
    <4>  Come sempre,  bene non accettare un input non valido.
    <5>  Senza questa pulizia dei caratteri residui, le successive getchar
         leggerebbero i caratteri avanzati dalla scanf, come minimo un \n.
    <6>  Assegna alla variabile finito il risultato del confronto. Notare
         che = significa assegnazione, mentre == significa confronto.
    <7>  Letteralmente: if not finito (se non ha finito).
    <8>  L'operatore ternario si pu usare anche con le stringhe della printf.
    <9>  Se il carattere letto con la getchar, ed assegnato a c,  diverso da
         newline... (il carattere rimane in c).
    <10> Notare l'uso dei caratteri tra apici, invece dei rispettivi codici
         numerici ASCII, per evidenziare quello che si sta facendo. 'a' segue
         'A' nel codice ASCII: aggiungendo la differenza tra i due codici
         si converte una lettera da maiuscola a minuscola.
    <11> Quando l'istruzione da eseguire condizionalmente con la if  molto
         breve, si usa anche scriverla di seguito sulla stessa linea anzich
         andare a capo ed indentare. In questo caso  bene mettere almeno
         due spazi per evidenziarla.
*/
