/*
   Questo programma fa parte del Corso di C
   Copyright (C) 1990 Gruppo Editoriale Jackson
   Copyright (C) 2002 Enrico Colombini
   Tutti i diritti riservati
*/


/* FATTORIA: calcola il fattoriale di un numero intero <1> */


#include <stdio.h>

main()
{
    long z;             /*numero introdotto <2>*/
    long f;             /*fattoriale calcolato*/
    long i;             /*temporanea per i calcoli*/

    const long zmax = 16;   /*limite perch il fattoriale stia in un long*/

    printf("\n Calcolo del fattoriale\n\n");        /*titolo*/

    do {                                            /*ciclo di input <3>*/
        z = 0L;                                     /*default <4>*/
        printf("Numero (0..%ld): ",zmax);           /*prompt*/
        scanf("%ld",&z);                            /*input numero*/
    } while (z < 0L || z > zmax);                   /*ripete se non ok <5>*/

    f = 1L;                                         /*calcolo fattoriale <6>*/
    for (i = z; i > 1; i--) {                       /*con moltipliche <7>*/
        f *= i;
    }

    printf("\n%ld! = %ld\n",z,f);                   /*stampa fattoriale*/
}

/*  Note:
    <1> Il fattoriale di n, cio n!, si ottiene moltiplicando n per tutti
        i numeri che lo precedono. Il fattoriale di 0  1 per definizione.
    <2> Usiamo un long perch i fattoriali crescono molto rapidamente: un
        int basterebbe appena a contenere il fattoriale di 7.
    <3> La do inizia il ciclo che sar controllato dalla while finale. E'
        sempre una buona idea controllare l'input, in modo da impedire che
        il programma elabori dati non validi.
    <4> Se la scanf non trova un valore valido, z rimane inalterato. Abbiamo
        deciso in questo caso di considerare zero il valore dato, perch
        altrimenti in certe situazioni il ciclo potrebbe girare all'infinito.
        Vedremo nel seguito del corso come migliorare il controllo dei dati
        introdotti dall'utente.
    <5> Se z  fuori del campo valido, il ciclo viene ripetuto. Il controllo
        al termine del ciclo  l'ideale per controllare la validit dei
        dati introdotti. Lo 0L sottolinea che z  un long.
    <6> 1L significa 1 long. Non ci sarebbero problemi anche a scrivere 1,
        in quanto il compilatore sa che f  un long, ma non fa mai male
        specificarlo.
    <7> Se z vale zero, questa for non viene eseguita nemmeno una volta. Di
        conseguenza f mantiene il valore assegnato in precedenza, cio 1.
        Questo  coerente con la definizione di fattoriale: 0! = 1.
*/
