/*
   Questo programma fa parte del Corso di C
   Copyright (C) 1990 Gruppo Editoriale Jackson
   Copyright (C) 2002 Enrico Colombini
   Tutti i diritti riservati
*/


/* LEGGENUM: legge un numero da tastiera <1> */


#include <stdio.h>
#include <ctype.h>

main()
{
    int n;          /*numero introdotto*/
    int valido;     /*vero se numero valido*/
    int neg;        /*vero se negativo*/
    int c;          /*carattere letto*/

    printf("\n Conversione da caratteri a numero decimale:\n");
    printf("\nScrivi un numero: ");

    while ( isspace(c = getchar()) )                /*salta spazi <2>*/
        ;
    neg = (c == '-');                               /*negativo?*/
    if (neg)  c = getchar();                        /*salta il segno*/

    valido = isdigit(c);                            /* un numero? <3>*/
    n = 0;                                          /*parte da zero*/
    while (isdigit(c)) {                            /*converte cifre <4>*/
        n *= 10;                                    /*sposta a sinistra*/
        n += (c-'0');                               /*aggiunge <5>*/
        c = getchar();                              /*legge altra cifra*/
    }
    while (c != '\n') {                             /*ripulisce <6>*/
        c = getchar();
    }
    if (neg)  n = -n;                               /*inverte se negativo*/

    if (valido) {                                   /*risultato*/
        printf("\nHai scritto il numero %d.\n",n);
    } else {
        printf("\n- Non hai introdotto un numero valido.\n");
    }
}

/*  Note:
    <1> Fa in pratica lo stesso lavoro della scanf con %d, anche se in
        forma leggermente semplificata.
    <2> E' consentito battere spazi, Tab o Return prima del numero.
    <3> Se il primo carattere dopo gli spazi non  una cifra numerica, non
         stato introdotto un numero valido.
    <4> La prima cifra del numero  gi in c, non occorre leggerla. Il ciclo
        prosegue finch ci sono cifre valide da leggere. Per ciascuna di
        queste, moltiplica per dieci il valore letto fino a quel momento
        ( come spostare il numero una colonna a sinistra) ed aggiunge il
        valore della nuova cifra.
    <5> c-'0'  il valore della cifra. Ad esempio, il carattere '5' vale 53
        (53  il codice ASCII di '5') ed il carattere '0' vale 48, perci
        '5'-'0' vale 53-48, ovvero 5, il valore della cifra che il carattere
        rappresenta.
    <6> Il primo carattere non numerico  gi in c, vedi nota 4.
*/
