/*
   Questo programma fa parte del Corso di C
   Copyright (C) 1990 Gruppo Editoriale Jackson
   Copyright (C) 2002 Enrico Colombini
   Tutti i diritti riservati
*/


/* MULTA: esempio di uso delle costanti */


#include <stdio.h>

main()
{
    #define MININP  -50                 /*limiti di input <1>*/
    #define MAXINP  5000

    enum { I_OK, I_FUORI, I_NONVAL };   /*situazioni di input <2>*/

    enum { FERMO = 0,                   /*valori dei limiti <3>*/
           INTRALCIO = 40,
           LIMITE1 = 50,
           LIMITE2 = 90,
           ASSURDO = 350 };

    #define    M_RETRO     19000L       /*e relative multe <4>*/
    #define    M_FERMO     25000L
    #define    M_INTRALCIO 30000L
    #define    M_LIMITE1   20000L
    #define    M_LIMITE10  50000L
    #define    M_LIMITE2   300000L
    #define    M_ASSURDO   413800L
    #define    M_GOMME     35000L
    #define    M_VISTA     40000L

    int in;         /*situazione dell'input*/
    int vel;        /*velocit*/
    long multa;     /*multa da pagare*/

    do {
        printf("\nChe velocit segna il tachimetro? ");
        if (scanf("%d",&vel) < 1) {                     /*input e test <5>*/
            in = I_NONVAL;
        } else if (vel < MININP || vel > MAXINP) {      /*controlla <6>*/
            in = I_FUORI;
        } else {
            in = I_OK;
        }
        if (in == I_FUORI) {
            printf("\n- Il valore dev'essere compreso tra %d e %d.\n",
                   MININP,MAXINP);                      /*<7>*/
        }
    } while (in == I_FUORI);                            /*ripete se non ok*/

    printf("\n- Lei  in contravvenzione per ");
    if (in == I_NONVAL) {
        printf("occhiali inadatti alla guida:\n"
               "  sul tachimetro ci sono numeri, non lettere o simboli.");
        multa = M_VISTA;                                /*<8>*/
    } else if (vel < FERMO) {
        printf("retromarcia in strada a senso unico.");
        multa = M_RETRO;
    } else if (vel == FERMO) {
        printf("sosta vietata.");
        multa = M_FERMO;
    } else if (vel < INTRALCIO) {
        printf("intralcio al traffico.");
        multa = M_INTRALCIO;
    } else if (vel <= LIMITE1) {
        printf("pneumatici sotto lo spessore minimo.");
        multa = M_GOMME;
    } else if (vel <= LIMITE1+10) {
        printf("eccesso di velocit.");
        multa = M_LIMITE1;
    } else if (vel < LIMITE2) {
        printf("eccesso di velocit di oltre 10 Km/h.");
        multa = M_LIMITE10;
    } else if (vel <= ASSURDO) {
        printf("eccesso di\n  velocit di %d km/h e guida pericolosa.",
               vel-LIMITE1);
        multa = M_LIMITE2;
    } else {
        printf("guida di aviogetto su strada urbana.");
        multa = M_ASSURDO;
    }

    printf("\n  Fanno %ld. E stia pi attento la prossima volta.\n ",multa);
}

/*  Note:
    <1> Un valore definito con #define viene sostituito ogni volta che
        la costante  usata nel programma. Per convenzione, le costanti
        definite con #define o enum sono indicate in lettere maiuscole.
    <2> In questo caso non importano i valori assegnati alle costanti,
        basta che siano diversi tra loro. Il compilatore assegna comunque
        zero alla prima, 1 alla seconda e 2 alla terza. Il trattino di
        sottolineatura (underline) si usa per migliorare la leggibilit,
        e conta come una normale lettera.
    <3> Qui ogni costante deve avere il suo valore. Avremmo anche potuto
        usare const, ma le costanti definite con enum non occupano memoria
        ed il programma gira pi velocemente.
    <4> Anche qui sarebbe stato utile enum, ma questo funziona solo con
        gli int e non con i long. Abbiamo quindi usato una serie di #define,
        che hanno lo svantaggio di non restare confinati alla funzione in
        cui sono definiti (main, in questo caso). Vedremo infatti come un
        programma possa consistere di pi funzioni.
    <5> Non importa conoscere il valore assegnato alla variabile (in) nei tre
        casi, basta sapere che si tratta di tre valori diversi. Chiamare le
        cose per nome e non per numero riduce le possibilit di errore.
    <6> I valori definiti con #define possono essere usati come normali
        numeri, ad esempio in un confronto...
    <7> ...come argomenti di una funzione (in questo caso printf)...
    <8> ...o in un'assegnazione. Dato che M_VISTA  definito come 40000L,
        questa espressione equivale a: multa = 40000L;. La sostituzione
        dei valori definiti con #define  sempre letterale, come se fossero
        riscritti ogni volta esattamente come indicati nella #define stessa.
*/
