/*
   Questo programma fa parte del Corso di C
   Copyright (C) 1990 Gruppo Editoriale Jackson
   Copyright (C) 2002 Enrico Colombini
   Tutti i diritti riservati
*/


/* TEXTSIN: disegna una sinusoide sulla pagina testo <1> */


#include <stdio.h>
#include <math.h>       /*<2>*/

main()
{
    const double pi = 3.1415926536;     /*pigreco*/
    const int ampMax = 39;              /*ampiezza massima sinusoide <3>*/
    const int puntiCiclo = 47;          /*numero di punti per ciclo <4>*/
    const int cSin = '*';               /*carattere per sinusoide*/
    const int cAsse = '|';              /*carattere per asse*/
    const double grad = pi/180.0;       /*per conversione gradi/radianti <5>*/

    double ang;                         /*angolo corrente, in radianti*/
    double passo;                       /*passo di variazione dell'angolo*/
    double val;                         /*valore della sinusoide nel punto*/
    int pos;                            /*posizione in caratteri*/
    int n,i;

    passo = 360.0/(puntiCiclo-1);                   /*passo tra due punti*/
    passo *= grad;                                  /*converte in radianti*/

    putchar('\n');                                  /*a capo*/
    ang = 0.0;                                      /*angolo iniziale*/
    for (n = 0; n < puntiCiclo; n++) {              /*scandisce punti*/
        val = sin(ang);                             /*valore nel punto <6>*/
        val *= ampMax;                              /*scaling in ampMax <7>*/
        pos = floor(val+0.5);                       /*approssima <8>*/

        for (i = -ampMax; i <= ampMax; i++) {       /*disegna punto <9>*/
            if (i == pos) {
                putchar(cSin);                      /*punto sinusoide*/
            } else if (i == 0) {
                putchar(cAsse);                     /*asse*/
            } else {
                putchar(' ');                       /*riempie con spazi*/
            }
        }
        putchar('\n');                              /*fine linea*/

        ang += passo;                               /*aggiorna angolo*/
    }
}

/*  Note:
    <1> Non potendo (con il C standard ANSI) posizionare il cursore nel
        punto desiderato del video, la sinusoide viene stampata dall'alto
        verso il basso, con l'asse ruotato di 90 gradi (cio verticale
        al centro dello schermo).
    <2> Per usare le funzioni trigonometriche si deve includere <math.h>.
    <3> ampMax  la massima distanza dall'asse, espressa in caratteri.
    <4> La sinusoide viene disegnata calcolandone il valore nel numero
        indicato di punti, e per ciascun punto disegnando un carattere cSin
        ad una distanza dall'asse proporzionale al valore calcolato. Questa
        tecnica  detta campionamento, cio misura del valore in un numero
        finito di punti.
    <5> Le funzioni trogonometriche del C lavorano in radianti, mentre noi
        siamo abituati ai gradi sessagesimali. Questa costante consente di
        passare dagli uni agli altri con una semplice moltiplicazione.
    <6> Calcola il valore della sinusoide all'angolo corrispondente al
        punto corrente. Il valore risultante  compreso tra -1 e +1.
    <7> Moltiplicando per ampMax risulta un valore compreso tra -ampMax e
        +ampMax. Questo  un esempio di scaling, o adattamento al campo
        di valori desiderato.
    <8> Il C non ha una funzione standard per approssimare all'intero pi
        vicino, ma ha la funzione floor (pavimento) che ritorna l'intero
        sottostante (4.3 diventa 4.0, 4.0 rimane 4.0, -4.3 diventa -5.0). Si
        pu approssimare un numero reale all'intero pi vicino aggiungendo
        0.5 prima di usare floor. L'assegnazione ad un intero causa il
        troncamento della parte frazionaria, d'altronde gi tolta da floor.
    <9> Per stampare un punto viene stampata un'intera linea sullo schermo,
        comprendente il punto e l'asse. Sono stampati anche gli spazi
        inutili sulla destra, per mantenere costante la velocit di
        disegno sul video. Usare la putchar non  la soluzione pi veloce,
        ed ha lo svantaggio di mostrare un fastidioso cursore. Ci sono
        istruzioni pi adatte, e sono considerate nella parte esperti.
*/
