/*
   Questo file fa parte del Corso di C
   Copyright (C) 1990 Gruppo Editoriale Jackson
   Copyright (C) 2002 Enrico Colombini
   Tutti i diritti riservati
*/


/* AGENDA.H: header per AGENDA <1>*/


/* costanti: */

#define LRIGA    16         /*Lunghezza riga di note, escluso 0 finale*/
#define NRIGHE   6          /*numero righe di note di un giorno*/


/* nuovi tipi di variabili: */

typedef char Nota[NRIGHE][LRIGA+1];  /*definisce il tipo Nota (un record)*/

typedef struct {            /*definisce il tipo Data <2>*/
    int anno;               /*anno (1990..1999)*/
    int bisest;             /*vero se anno bisestile*/
    int ultimo;             /*ultimo giorno valido dell'anno (364/365) <3>*/
    int giorno;             /*giorno progressivo (0..365)*/
    int mese;               /*mese (0..11)*/
    int gmese;              /*giorno del mese (1..31)*/
    int gsett;              /*giorno della settimana (0..6)*/
} Data;

typedef struct {            /*definisce il tipo Giorno:*/
    char *nome;             /*nome del giorno*/
    int  hpos;              /*e posizione sul video*/
    int  vpos;
} Giorno;

typedef struct {            /*definisce il tipo Mese:*/
    char *nome;             /*nome del mese*/
    int  giorni;            /*e durata in giorni*/
} Mese;


/* variabili globali (dichiarazioni): <4> */

extern Mese mesi[];         /*dati dei mesi*/
extern Giorno giorni[];     /*dati dei giorni*/


/* Note su dichiarazioni e costanti:
    <1> A differenza del programma LIBRI (lezione E3), nello header di
        AGENDA sono dichiarate solamente costanti e variabili usate da pi
        di un file. Quelle usate da un solo file sono dichiarate nel file
        stesso, per migliorare l'indipendenza dei vari moduli.
    <2> Tutti i calcoli di AGENDA fanno riferimento alla componente giorno
        del tipo Data, cio al giorno progressivo (0 = 1.o Gennaio). Gli
        altri valori (mese, gmese, gsett) sono ricalcolati a partire da
        giorno. Un riferimento unico evita molte possibilit di errore.
    <3> L'ultimo giorno dell'anno potrebbe facilmente essere determinato
        in base a bisest, ed  quindi apparentemente spazio sprecato. Ma
        viene usato spesso, e quindi vale la pena di tenerlo, tanto pi che
        nel programma ci sono pochissime variabili di tipo Data.
    <4> Queste sono le uniche variabili globali del programma (vedi nota 1).
        Meno variabili globali ci sono, pi il programma  affidabile: un
        eventuale errore  comunque confinato all'interno di un modulo. Tra
        l'altro, mesi[] e giorni[] sono tabelle che, una volta inizializzate,
        non cambiano pi: in pratica, sono delle costanti.
*/


/* prototipi funzioni: */

void CicloComandi(void);                         /*file AGENDA.C (main)*/

void MostraSettimana(Data *dp);                  /*file AGEVIDEO.C*/
void CancellaNota(int gs);
void MostraNota(Nota n,int gs);
void EditNota(Data *dp);
void DisegnaFinestra(int anno);
void Menu(int m);

void LeggeData(Data *pd);                        /*file AGETIME.C*/
int  RicavaData(Data *pd);
int  SpostaData(Data *pd, int n);
void CambiaMese(Data *pd, int n);

int  ApreFile(int anno);                         /*file AGEFILE.C*/
int  CreaFile(char *nome);
void ChiudeFile(void);
void LeggeNota(Nota n,int g);
void ScriveNota(Nota n,int g);
int  ErFile(void);

int  Domanda(char *d);                           /*file AGEUTIL.C*/
int  SiNo(char *d);
void Errore(char *e);
void Messaggio(char *s);
void PutsAt(int x, int y, char *s);
void PutNchar(int n, int c);
int  InputStringa(char *s, int lmax, int px, int py);
void Inverse(int inv);
