/*
   Questo programma fa parte del Corso di C
   Copyright (C) 1990 Gruppo Editoriale Jackson
   Copyright (C) 2002 Enrico Colombini
   Tutti i diritti riservati
*/


/* FATTORIC: calcola il fattoriale con tecnica ricorsiva */


#include <stdio.h>


#define MAXNUM 16L          /*limite perch il fattoriale stia in un long*/


long Fattoriale(long x);    /*prototipo della funzione*/


/********************************************************************
 * main <1>
 ********************************************************************/

main()
{
    long n = 0L;            /*numero introdotto, con default <2>*/
    long f;                 /*fattoriale calcolato*/

    printf("\n Calcolo del fattoriale"
           " in modo ricorsivo:\n\n");              /*titolo*/

    do {                                            /*ciclo di input*/
        printf("Numero (0..%d): ",MAXNUM);          /*prompt*/
        scanf("%ld",&n);                            /*input numero <3>*/
    } while (n < 0L || n > MAXNUM);                 /*ripete se non ok */

    putchar('\n');
    printf("\n %ld! = %ld\n",n,Fattoriale(n));      /*stampa fattoriale*/
}

/*  Note su main:
    <1> A parte la ricorsione, il programma  fondamentalmente identico
        a FATTORIA della lezione B4.
    <2> Questo valore rester in n in caso di input non valido.
    <3> Se il valore introdotto non  un numero, o se si batte EOF (Ctrl-Z
        o F6), rimane in n il valore precedente, cio 0L.
*/


/********************************************************************
 * Fattoriale: ritorna il fattoriale di x.
 ********************************************************************/

long Fattoriale(long x)
{
    static int liv = 0;     /*per mostrare il livello di ricorsione <1>*/

    printf("Entra nel livello %d con x=%ld\n",++liv,x);       /*entrata <2>*/

    x = (x < 2) ? 1 : x*Fattoriale(x-1);            /*calcola fattoriale <3>*/

    printf("Esce dal livello %d ritornando %ld\n",liv--,x);   /*uscita <4>*/

    return x;                                       /*ritorna fattoriale <5>*/
}

/* Note su Fattoriale:
    <1> La funzione sarebbe composta da una sola linea (vedi nota 3). Il
        resto serve solo per mostrare il funzionamento della ricorsione. In
        particolare, la variabile liv  statica, e quindi  una sola per
        tutte le 'incarnazioni' della funzione Fattoriale. La usiamo per
        tener conto del livello di ricorsione corrente, cio quante volte
        la funzione  stata chiamata o si  richiamata.
    <2> Ogni volta che la funzione viene chiamata, incrementa l'indicatore
        del livello di ricorsione e lo mostra insieme al valore della
        variabile x (il parametro ricevuto).
    <3> Questa linea svolge il lavoro, e potrebbe iniziare con return,
        senza bisogno di assegnare il risultato ad x. Se x  0 o 1, il
        fattoriale di x  1; altrimenti, il fattoriale di x si ottiene
        moltiplicando x per il fattoriale di x-1. Per chiarezza abbiamo
        tralasciato la L in coda alle costanti long (funziona correttamente
        in ogni caso, dato che x  dichiarata long).
    <4> Ogni volta che la funzione termina, mostra il livello che sta per
        chiudersi ed il valore del risultato x, e decrementa il livello.
    <5> Ritorna alla funzione che l'ha chiamata, che ai livelli inferiori
         sempre la Fattoriale stessa. Il risultato finale viene costruito
        con le moltiplicazioni che avvengono durante i successivi ritorni
        prima di emergere al livello base, come si pu osservare facendo
        girare il programma ed esaminando le informazioni stampate.

   Ecco come sarebbe la funzione Fattoriale, ripulita delle istruzioni
   aggiunte solo per osservare il meccanismo della ricorsione:

     long Fattoriale(long x)
     {
         return (x < 2) ? 1 : x*Fattoriale(x-1);
     }

*/

