/*
   Questo programma fa parte del Corso di C
   Copyright (C) 1990 Gruppo Editoriale Jackson
   Copyright (C) 2002 Enrico Colombini
   Tutti i diritti riservati
*/


/* INVESTE: calcolo dell'interesse composto */


#include <stdio.h>


long   InputLong(long mi, long ma);     /*prototipi delle funzioni usate <1>*/
double InputDouble(double mi, double ma);

/* Nota sui prototipi di funzione:
    <1> I prototipi di funzione consentono un controllo del corretto tipo
        e numero di argomenti nelle chiamate, e del valore ritornato. Sono
        da usare in ogni circostanza, indicando al compilatore di segnalare
        errore (o almeno warning) se non sono indicati. Devono stare
        all'inizio del programma.
*/


/********************************************************************
 * main
 ********************************************************************/

main()
{
    long   capIniziale;     /*capitale iniziale*/
    double interesse;       /*interesse in % (solo interi)*/
    long   anni;            /*periodo di investimento*/
    long   capFinale;       /*capitale finale*/
    double fm;              /*fattore di moltiplicazione*/
    int    i;

    printf("\n Calcolo dell'interesse composto:\n\n");

    printf("Quanto vuoi investire ? ");
    capIniziale = InputLong(1000L,10000000L);       /*<1>*/
    printf("A che interesse (%%)   ? ");
    interesse = InputDouble(0.1,30.0);              /*<2>*/
    printf("Per quanti anni       ? ");
    anni = InputLong(1L,50L);

    capFinale = capIniziale;                        /*inizia con ci che ha*/
    fm = 1.0+(interesse/100.0);                     /*calcola fatt. molt.*/
    for (i = 0; i < anni; i++) {                    /*investe*/
        capFinale = capFinale*fm+0.5;               /*(arrotonda) <3>*/
    }

    printf("\n%ld lire investite al %.2lf%% per"
           " %ld anni diventano %ld lire.\n",
           capIniziale,interesse,anni,capFinale);   /*risultato <4>*/
}

/*  Note su main:
    <1> La InputLong, definita pi avanti, chiede di introdurre un long
        compreso tra i due limiti indicati. Notare l'uso di L nelle costanti
        long (non essenziale, dato che c' il prototipo di funzione, ma
        comunque consigliabile per chiarezza).
    <2> La InputDouble  analoga alla InputLong: accetta un double compreso
        tra i due limiti indicati.
    <3> Prima della moltiplicazione tra il long capFinale ed il float fm,
        il primo viene automaticamente convertito a float. Il risultato 
        un float. Poich l'assegnazione al long capFinale comporta la
        perdita della parte frazionaria, si aggiunge 0.5 in modo che avvenga
        invece un arrotondamento all'intero pi vicino (questa tecnica vale
        per numeri positivi, una versione pi generale  usata nel programma
        TEXTSIN della lezione 4 ed impiega la funzione floor).
    <4> La specifica %.2lf stampa un double con due cifre dopo il punto
        decimale. Il %% che segue stampa un simbolo di %.
*/


/********************************************************************
 * InputLong: input di long compreso tra mi e ma, ritorna il valore
 *            introdotto, ripete l'input se il valore non  valido.
 ********************************************************************/

long InputLong(long mi, long ma)        /*<1>*/
{
    long num;       /*numero introdotto*/
    int  risulta;   /*risultato della scanf*/
    int  valido;    /*flag di numero valido*/

    do {
        risulta = scanf("%ld",&num);                /*legge numero <2>*/
        if (risulta != EOF) {                       /*ripulisce se non EOF*/
            while (getchar() != '\n')
                ;
        }
        valido = (risulta == 1 && num >= mi
                  && num <= ma);                    /*controlla se ok <3>*/
        if (! valido) {                             /*segnala errore*/
            printf("Devi introdurre un numero intero"
                   " compreso tra %ld e %ld: \a",mi,ma);
        }
    } while (! valido);                             /*ripete se non ok*/

    return num;                                     /*ritorna valore <4>*/
}

/*  Note su InputLong:
    <1> Sono dichiarati sia il tipo dei parametri mi e ma (long) che il
        tipo ritornato dalla funzione (anch'esso long).
    <2> La scanf usa %ld per leggere un long nella variabile num.
    <3> Il test di validit confronta con il minimo ed il massimo
        specificati dai parametri mi e ma. Non abbiamo usato i nomi min
        e max perch alcuni compilatori li usano per altro scopo.
    <4> Il valore ritornato  del tipo specificato all'inizio della
        funzione, cio un long.
*/


/********************************************************************
 * InputDouble: input di double compreso tra mi e ma, ritorna valore
 *              introdotto, ripete l'input se il valore non  valido.
 ********************************************************************/

double InputDouble(double mi, double ma)
{
    double num;        /*numero introdotto*/
    int    risulta;    /*risultato della scanf*/
    int    valido;     /*flag di numero valido*/

    do {
        risulta = scanf("%lf",&num);                /*legge numero <1>*/
        if (risulta != EOF) {                       /*ripulisce se non EOF*/
            while (getchar() != '\n')
                ;
        }
        valido = (risulta == 1 && num >= mi
                  && num <= ma);                    /*controlla se ok*/
        if (! valido) {                             /*segnala errore <2>*/
            printf("Devi introdurre un numero"
                   " compreso tra %.2lf e %.2lf: \a",mi,ma);
        }
    } while (! valido);                             /*ripete se non ok*/

    return num;                                     /*ritorna valore <3>*/
}

/*  Note su InputDouble:
    <1> La scanf usa %lf per leggere un double nella variabile num.
    <2> Nella stringa stampata in caso di errore, i valori minimo e massimo
        ammessi sono mostrati con due cifre dopo il punto decimale. Questo
        riduce in qualche misura la versatilit della funzione.
    <3> In questo caso viene ritornato un double, coerentemente con
        la definizione della funzione e con il relativo prototipo.
*/
