/*
   Questa libreria fa parte del Corso di C
   Copyright (C) 1990 Gruppo Editoriale Jackson
   Copyright (C) 2002 Enrico Colombini
   Tutti i diritti riservati
*/


/* JGRAPH: 'libreria' (in realt un normale modulo) di funzioni grafiche */
/*         compilabili con Turbo C 2.0 e con Quick C 2.0, versione E5.   */


#include "Jgraph.h"                         /*prototipi funzioni e costanti*/


/********************************************************************
 * Funzioni per il Turbo C 2.0 non definite come macro in Jgraph.h
 ********************************************************************/

#ifdef __TURBOC__                                   /*compila se Turbo C*/

  #include <stddef.h>                               /*per definire NULL <1>*/

  /* Jinitgraph: sceglie il modo grafico pi definito, ritorna vero se ok */

  int Jinitgraph(void)                              /*<2>*/
  {
      int driver = DETECT;                          /*sceglie da s*/
      int modo;

      initgraph(&driver,&modo,NULL);                /*avvia grafica*/
      return (driver > 0);                          /*vero se ok*/
  }

  /* Note su Jinitgraph:
      <1> <stddef.h>  uno header che contiene le definizioni di alcune
          costanti fondamentali. Lo usiamo per definire NULL senza dover
          includere il ben pi corposo <stdio.h>, che potrebbe aumentare
          inutilmente le dimensioni del programma. Il valore di NULL non
           noto, ed  quindi sconsigliabile definirlo direttamente.
      <2> La funzione  commentata nel programma RIMBALZA della lezione E4.
  */


/********************************************************************
 * Funzioni per il Quick C 2.0 non definite come macro in Jconio.h
 ********************************************************************/

#else                                               /*compila se Quick C*/

  /* Jinitgraph: sceglie il modo grafico pi definito, ritorna vero se ok */

  int Jinitgraph(void)                              /*<1>*/
  {
      int modi[] = {          /*lista dei modi in ordine di preferenza*/
          _VRES16COLOR,       /*VGA 640 x 480*/
          _ERESCOLOR,         /*EGA colore 640 x 350*/
          _ERESNOCOLOR,       /*EGA monocromatica 640 x 350*/
          _ORESCOLOR,         /*Olivetti 640 x 400*/
          _HERCMONO,          /*Hercules 720 x 348*/
          _HRESBW,            /*CGA 640 x 400*/
          _DEFAULTMODE        /*segna fine lista*/
      };
      int i;

      i = 0;                                        /*avvia grafica*/
      while (modi[i] != _DEFAULTMODE
        && _setvideomode(modi[i]) == 0) {
          i++;
      }

      return (modi[i] != _DEFAULTMODE);             /*1 se ok*/
  }

  /* Note su Jinitgraph:
      <1> La funzione  commentata nel programma RIMBALZA della lezione E4.
  */

  /* JgetQuickGraphInfo: dimens. x se n==1, y se n==2, n. colori se n==3. */

  int JgetQuickGraphInfo(int n)
  {
      static int prima = -1;           /*vera se prima chiamata*/
      static struct videoconfig dv;    /*dati del modo video corrente*/

      if (prima) {                                  /*prima chiamata*/
          _getvideoconfig(&dv);                     /*legge dati video*/
          prima = 0;                                /*non rifarlo pi*/
      }

      return (n == 1) ? dv.numxpixels :
             (n == 2) ? dv.numypixels : dv.numcolors;
  }


#endif                                      /*fine compilazione condizionale*/
