/*
   Questo programma fa parte del Corso di C
   Copyright (C) 1990 Gruppo Editoriale Jackson
   Copyright (C) 2002 Enrico Colombini
   Tutti i diritti riservati
*/


/* MCD: calcola il massimo comune divisore di due numeri */


#include <stdio.h>


/********************************************************************
 * main
 ********************************************************************/

main()
{
    int a,b;        /*due interi positivi*/
    int mcd;        /*massimo comune divisore*/

    printf("\n Calcolo del massimo comune divisore:\n\n");

    printf("Primo numero  : ");                     /*input valori <1>*/
    a = InputIpos();
    printf("Secondo numero: ");
    b = InputIpos();

    mcd = CalcolaMcd(a,b);                          /*calcola mcd <2>*/

    printf("\nIl massimo comune divisore di"
           " %d e %d  %d.\n",a,b,mcd);             /*risultato*/
}

/*  Note su main:
    <1> Usare una funzione separata per l'input migliora molto la
        leggibilit: i dettagli sono racchiusi nella funzione InputIpos
        e non disturbano il programma, che risulta breve e comprensibile.
    <2> Anche il lavoro vero e proprio  svolto da un'apposita funzione,
        che riceve i valori di a e b passati come argomenti. E' come se
        il C disponesse delle due nuove istruzioni InputIpos e CalcolaMcd.
        Una funzione risulta quindi utile e conveniente anche se viene
        chiamata una sola volta.
*/


/********************************************************************
 * CalcolaMcd: ritorna il massimo comune divisore di n1 e n2.  <1>
 ********************************************************************/

CalcolaMcd(int n1, int n2)      /*<2>*/
{
    while (n1 != n2) {                              /*finch diversi <3>*/
        if (n1 > n2) {                              /*sottrae min da max*/
            n1 -= n2;                               /*<4>*/
        } else {
            n2 -= n1;
        }
    }
    return n1;                                      /*ritorna mcd <5>*/
}

/*  Note su CalcolaMcd:
    <1> Nel commento che introduce la funzione vanno descritti anche il
        significato e l'uso dei parametri.
    <2> Se una funzione ha dei parametri, questi vanno descritti nella linea
        che definisce la funzione stessa. In questo caso n1 e n2 sono due
        parametri int, che si comportano come variabili locali il cui valore
        iniziale  quello degli argomenti passati nella chiamata. Dunque n1
        avr il valore di a del main, mentre n2 avr il valore di b nel main
        (vedi nota 2 del main).
    <3> L'algoritmo per il calcolo del massimo comune divisore (mcd) si basa
        su due fatti:
            a) se i due numeri sono uguali, il mcd  il numero stesso.
            b) il mcd della differenza tra i numeri (il maggiore
               meno il minore)  uguale al mcd dei due numeri.
    <4> Poich i parametri (n1, n2) sono a tutti gli effetti delle variabili
        locali, possono essere liberamente alterati senza per questo
        alterare il valore degli argomenti indicati nella funzione chiamante,
        cio a e b del main.
    <5> Come sempre, la return restituisce al chiamante il valore indicato.
*/


/********************************************************************
 * InputIpos: input di intero positivo, ritorna il valore introdotto,
 *            ripete l'input se il valore non  valido.
 ********************************************************************/

InputIpos()         /*<1>*/
{
    int num;        /*numero introdotto*/
    int risulta;    /*risultato della scanf*/
    int valido;     /*flag di numero valido*/

    do {
        risulta = scanf("%d",&num);                 /*legge numero*/
        if (risulta != EOF) {                       /*ripulisce se non EOF*/
            while (getchar() != '\n')
                ;
        }
        valido = (risulta == 1 && num > 0);         /*controlla se ok <2>*/
        if (! valido) {                             /*segnala errore*/
            printf("Devi introdurre un intero positivo: \a");
        }
    } while (! valido);                             /*ripete se non ok*/

    return num;                                     /*ritorna valore*/
}

/*  Note su InputIpos:
    <1> La InputIpos  una variante della InputInt usata nel programma
        MINMAX: questa accetta solo interi positivi.
    <2> La differenza rispetto a InputInt sta in questo test e nel seguente
        messaggio di errore.
*/
