/*
   Questo programma fa parte del Corso di C
   Copyright (C) 1990 Gruppo Editoriale Jackson
   Copyright (C) 2002 Enrico Colombini
   Tutti i diritti riservati
*/


/* MINMAX: minimo e massimo dei valori introdotti */


#include <stdio.h>
#include <limits.h>     /*<1>*/


/********************************************************************
 * main: il programma principale.
 ********************************************************************/

main()
{
    enum { NMIN = 2, NMAX = 10 };   /*numero minimo e massimo valori <2>*/

    int numVal;     /*numero valori*/
    int minimo;     /*valore minimo*/
    int massimo;    /*valore massimo*/
    int i,v;

    printf("\n Minimo e massimo di n valori:\n\n");

    do {
        printf("Quanti valori vuoi introdurre (%d-%d)? ",NMIN,NMAX);
        numVal = InputInt();                        /*input num. valori <3>*/
    } while (numVal < NMIN || numVal > NMAX);       /*ripete se non ok*/
    putchar('\n');                                  /*a capo*/

    minimo = INT_MAX;                               /*prepara <4>*/
    massimo = INT_MIN;

    for (i = 1; i <= numVal; i++) {                 /*ciclo di input*/
        printf("Valore n.%d: ",i);
        v = InputInt();                             /*legge un valore <5>*/
        if (v > massimo)  massimo = v;              /*aggiorna min & max <6>*/
        if (v < minimo)  minimo = v;
    }

    printf("\nValore minimo introdotto : %d"        /*risultati*/
           "\nValore massimo introdotto: %d\n",
           minimo,massimo);
}

/*  Note su main:
    <1> <limits.h> definisce una serie di costanti che indicano il campo di
        valori usabili con ciascun tipo, ad esempio il valore massimo e
        minimo che possono essere contenuti in un int (vedi nota 4).
    <2> enum  la tecnica migliore per definire costanti intere da usare
        solo all'interno di una certa funzione (es. main).
    <3> Questa  una chiamata alla funzione InputInt. La funzione viene
        eseguita, ed il valore ritornato da InputInt  assegnato alla
        variabile numVal. Una funzione definita dal programmatore si usa
        quindi esattamente come una funzione di libreria.
    <4> INT_MAX ed INT_MIN, definiti in <limits.h> (vedi nota 1) sono
        rispettivamente il valore massimo e minimo contenibile in un int.
        (in alternativa a questa soluzione, le variabili minimo e massimo
        potevano essere inizializzate con il primo dei valori introdotti).
    <5> Ancora una chiamata alla funzione InputInt. Racchiudere un'operazione
        logicamente indipendente in un'apposita funzione sarebbe comunque
        consigliabile anche se fosse usata una sola volta nel programma.
    <6> Quando l'istruzione controllata dalla if  molto semplice, pu essere
        leggibile anche se scritta sulla stessa linea, separata da due spazi.
*/


/********************************************************************
 * InputInt: input di un int, ritorna il valore introdotto,  <1>
 *           ripete l'input se il valore non  valido.
 ********************************************************************/

InputInt()          /*<2>*/
{
    int num;        /*numero introdotto <3>*/
    int risulta;    /*risultato della scanf*/
    int valido;     /*flag di numero valido*/

    do {
        risulta = scanf("%d",&num);                 /*legge numero*/
        if (risulta != EOF) {                       /*pulisce se non EOF <4>*/
            while (getchar() != '\n')
                ;
        }
        valido = (risulta == 1);                    /*controlla se ok*/
        if (! valido) {                             /*segnala errore <5>*/
            printf("Devi introdurre un numero intero: \a");
        }
    } while (! valido);                             /*ripete se non ok*/

    return num;                                     /*ritorna valore <6>*/
}

/*  Note su InputInt:
    <1> Ogni funzione va commentata per indicarne l'uso ed il valore
        ritornato (se c'). Questi commenti sono essenziali per una
        accettabile leggibilit del programma.
    <2> Una funzione si definisce come la main, aprendo e chiudendo le
        parentesi tonde, senza punto e virgola. Seguono le istruzioni,
        in un blocco delimitato da una coppia di parentesi graffe.
    <3> Le variabili dichiarate in una funzione sono locali alla funzione
        stessa, cio non visibili dal main o da altre funzioni. Non hanno
        alcun valore garantito all'entrata della funzione, e comunque
        perdono il loro valore quando la funzione termina l'esecuzione.
    <4> Se il primo carattere ricevuto dalla scanf  Ctrl-Z, o il tasto F6,
        questa ritorna immediatamente EOF. In questo caso non c' alcun
        resto di linea da ripulire. E' un caso improbabile, ma un buon
        programmatore deve tener conto di tutte le possibilit e scrivere
        programmi a prova di errore di manovra.
    <5> Il carattere '\a' nella stringa di errore non viene stampato, ma fa
        suonare un beep dall'altoparlante (scrivendolo al termine della
        stringa, viene percepito dall'utente come contemporaneo alla stampa).
    <6> L'istruzione return ritorna il valore indicato alla funzione
        chiamante, dove pu essere usato in un'espressione (vedi note
        3 e 5 relative a main).
*/
