/*
   Questo programma fa parte del Corso di C
   Copyright (C) 1990 Gruppo Editoriale Jackson
   Copyright (C) 2002 Enrico Colombini
   Tutti i diritti riservati
*/


/* ERONE: calcola l'area di un triangolo dati i tre lati */


#include <stdio.h>
#include <math.h>


void InputLati(double *pa, double *pb, double *pc);   /*prototipi funzioni*/
void FormulaErone(double a, double b, double c,
                  double *pa, double *pp);
double InputDouble(double mi, double ma);


#define LATOMIN 0.01                /*lunghezza minima di un lato <1>*/
#define LATOMAX 1000.0              /*lunghezza massima di un lato*/


main()
{
    double a,b,c;       /*lati del triangolo*/
    double area;        /*risultati*/
    double perimetro;

    printf("\n Calcola l'area di un triangolo con la formula di Erone:\n\n");

    InputLati(&a,&b,&c);                            /*input in a,b,c <2>*/
    FormulaErone(a,b,c,&area,&perimetro);           /*calcola area,perim.<3>*/

    printf("\nArea del triangolo      : %.2lf"
           "\nPerimetro del triangolo : %.2lf\n",area,perimetro);
}

/*  Note su main:
    <1> Queste costanti sono usate solamente nella funzione InputLati, ma
        sarebbe sbagliato definirle nella funzione stessa. Dato che indicano
        dei limiti che hanno effetto sul funzionamento del programma,  bene
        definirle all'inizio, dove sono facilmente visibili e modificabili.
        #define  l'ideale per costanti accessibili dall'intero programma; se
        fossero state limitate ad una funzione avremmo usato const (a prezzo
        di un poco di memoria), dato che enum non  usabile con i double.
    <2> Passando alla InputLati l'indirizzo (non il contenuto) delle tre
        variabili a,b,c, la funzione sar in grado di modificare il contenuto
        delle variabili stesse. Le variabili sono passate per riferimento.
    <3> La funzione FormulaErone riceve i valori delle variabili a,b,c, che
        non pu quindi modificare (passaggio per valore), mentre riceve gli
        indirizzi delle variabili area e perimetro, delle quali pu alterare
        il valore (passaggio per riferimento).
*/


/********************************************************************
 * InputLati: input lati triangolo in variabili puntate da pa, pb, pc.
 *            La lunghezza dev'essere compresa tra LATOMIN e LATOMAX.
 ********************************************************************/

void InputLati(double *pa, double *pb, double *pc)      /*<1>*/
{
    printf("Lunghezza del primo lato   : ");
    *pa = InputDouble(LATOMIN,LATOMAX);                 /*<2>*/
    printf("Lunghezza del secondo lato : ");
    *pb = InputDouble(LATOMIN,LATOMAX);
    printf("Lunghezza del terzo lato   : ");
    *pc = InputDouble(LATOMIN,LATOMAX);
}

/*  Note su InputLati:
    <1> La funzione dichiara come parametri tre pointer a double. Difatti
        un pointer pu contenere l'indirizzo di una variabile, e InputLati
        viene chiamata con tre indirizzi come argomenti (vedi main, nota 2).
        I tre pointer pa, pb e pc conterranno dunque, al momento della
        chiamata, gli indirizzi delle tre variabili a,b,c del main.
    <2> Se il pointer pa contiene l'indirizzo di una variabile (la a del
        main), l'espressione *pa indica la cosa puntata dal pointer pa, cio
        la variabile stessa (a). Questa linea assegna quindi il valore
        ritornato dalla InputDouble alla variabile puntata da pa, cio ad a.
*/


/********************************************************************
 * FormulaErone: calcola area e perimetro di un triangolo dati i tre
 *               lati a,b,c. Ritorna area in *pa, perimetro in *pp.
 ********************************************************************/

void FormulaErone(double a, double b, double c,
                  double *pa, double *pp)           /*<1>*/
{
    double p2;      /*semiperimetro*/

    *pp = a+b+c;                                    /*calcola perimetro <2>*/
    p2 = *pp/2;                                     /*semiperimetro*/
    *pa = sqrt(p2*(p2-a)*(p2-b)*(p2-c));            /*e area*/
}

/*  Note su FormulaErone:
    <1> La funzione riceve tre valori double nei parametri a,b,c, attraverso
        i quali non  possibile modificare le corrispondenti variabili della
        funzione chiamante, e riceve invece due indirizzi nei parametri pa
        e pp. Questi sono due pointer a double, attraverso i quali si pu
        modificare il valore della variabile indirizzata.
    <2> *pp  la variabile puntata dal pointer pp, cio quella di cui il
        pointer pp contiene l'indirizzo, cio la variabile perimetro del
        main (vedi nota 3 del main).
*/


/********************************************************************
 * InputDouble: input di double compreso tra mi e ma, ritorna valore
 *              introdotto, ripete l'input se il valore non  valido.
 ********************************************************************/

double InputDouble(double mi, double ma)    /*<1>*/
{
    double num;     /*numero introdotto*/
    int risulta;    /*risultato della scanf*/
    int valido;     /*flag di numero valido*/

    do {
        risulta = scanf("%lf",&num);                /*legge numero*/
        if (risulta != EOF) {                       /*ripulisce se non EOF*/
            while (getchar() != '\n')
                ;
        }
        valido = (risulta == 1 && num >= mi
                  && num <= ma);                    /*controlla se ok*/
        if (! valido) {                             /*segnala errore*/
            printf("Devi introdurre un numero"
                   " compreso tra %.2lf e %.2lf: \a",mi,ma);
        }
    } while (! valido);                             /*ripete se non ok*/

    return num;                                     /*ritorna valore*/
}

/*  Note su InputDouble:
    <1> InputDouble  commentata nel programma INVESTE della lezione B5.
*/
