/*
   Questo programma fa parte del Corso di C
   Copyright (C) 1990 Gruppo Editoriale Jackson
   Copyright (C) 2002 Enrico Colombini
   Tutti i diritti riservati
*/


/* ERRORI.C: intercetta gli errori hardware, chiede all'utente cosa fare */


#include <stdio.h>
#include <dos.h>

#include "finutil.h"                /*usa modulo finestre <1>*/
#include "Jconio.h"                 /*e libreria di console*/


#define  fileProva  "ERRORI.C"      /*file da leggere <2>*/


#ifdef  __TURBOC__                  /*definizioni per il Turbo C <3>*/

  #define  ErroreHardware  ErrHw(int cod, int ax, int bp, int si)

#else                               /*definizioni per il Quick C*/

  #define  ErroreHardware  ErrHw(unsigned ax, unsigned cod, unsigned far *p)
  #define  harderr         _harderr

#endif


enum {                              /*da ritornare in caso di errore*/
    ERR_IGNORA = 0,
    ERR_RITENTA = 1,
    ERR_ESCI = 2
};


/* prototipi funzioni: */

int ErroreHardware;                 /* una macro <4>*/


/* Note sulle dichiarazioni:
    <1> Per aprire una finestra, usiamo le funzioni del modulo FINUTIL. In
        questo modo la finestra di errore  l'ultima aperta sullo stack delle
        finestre, ed il programma potrebbe aprirne di proprie senza problemi.
    <2> ERRORI si limita a listare il contenuto del file indicato.
    <3> Visto che lo handler di errore  dichiarato diversamente nei due
        compilatori, lo definiamo in modo opportuno a seconda del compilatore
        usato. Prototipo di funzione e relativa dichiarazione si limiteranno
        quindi ad usare la macro ErroreHardware, mentre lo handler vero e
        proprio sar noto al programma (ed al linker) come ErrHw.
    <4> Vedi nota 3.
*/


/********************************************************************
 * main
 ********************************************************************/

main()
{
    FILE *prova;
    int  c;

    Jcursor(0);                                     /*spegne cursore*/

    harderr(ErrHw);                                 /*installa handler <1>*/

    prova = fopen(fileProva,"rb");                  /*apre in lettura <2>*/
    if (prova == NULL) {                            /*controlla se ok*/
        Jputs("\r\n- Non trovo il file " fileProva "\r\n");
    } else {

        Jputs("\r\n- Premi un tasto per listare il"
              " contenuto del file " fileProva ".\r\n\n"
              "(apri lo sportellino del drive se vuoi causare un errore): ");

        Jclrkey();                                  /*pulisce buffer*/
        while (! kbhit())  ;                        /*aspetta un tasto*/
        Jputs("\r\n\n");                            /*a capo due volte*/

        while ( (c = fgetc(prova)) != EOF) {        /*lista contenuto <3>*/
            Jputch(c);
        }

        Jputs("\r\nFine listato " fileProva ".\r\n");
        Jputs("\r\n");                              /*a capo*/
        fclose(prova);                              /*fine ok, chiude <4>*/
    }

    Jcursor(1);                                     /*riaccende cursore*/
}

/* Note su main:
    <1> Avvisa il DOS di chiamare lo handler ErrHw in caso di errore,
        invece di mostrare il suo intimidatorio messaggio. Vedi anche nota
        3 delle dichiarazioni.
    <2> Il file  aperto in modo binario perch cos vengono letti sia i \r
        che i \n alla fine di ogni linea. Questo  necessario in quanto
        FINUTIL scrive sul video con la libreria di console, che richiede
        \r\n e non solo \n per andare a capo.
    <3> Smette quando il file  finito (EOF), ma pu anche darsi che il
        programma termini pi brutalmente, per effetto di un errore.
    <4> Arriva qui solo se non ci sono stati errori, o se sono stati
        annullati riprovando l'operazione dopo averne corretto la causa.
*/


/********************************************************************
 * ErroreHardware: chiamata dal DOS in caso di errore hardware.
 ********************************************************************/

int ErroreHardware           /* una macro <1>*/
{
    enum { ESC = 0x1b };     /*tasto Escape*/
    char buf[80];
    int  c;

    if (ApreFinestra(15,7,65,12) == 0) {            /*finestra errore <2>*/
        c = ESC;                                    /*se non pu, esce*/
    } else {
        cod &= 0xff;                                /*pulisce codice <3>*/
        Jputch('\a');                               /*segnala errore*/
        Wputs(" Errore");                           /*<4>*/

        if ((ax & 0x8000) == 0) {                   /*se errore disco <5>*/
            sprintf(buf," di accesso al drive %c"   /*mostra drive <6>*/
                    ":\n\n (",'A'+(ax & 0xff));
            Wputs(buf);

            if (cod == 0x00) {                      /*messaggi errore <7>*/
                Wputs("il dischetto  protetto dalla scrittura");
            } else if (cod == 0x01) {
                Wputs("il drive indicato non  valido");
            } else if (cod == 0x02) {
                Wputs("manca il dischetto nel drive");
            } else if (cod == 0x04 || cod == 0x08 || cod == 0x0b) {
                Wputs("lettura dati non riuscita");
            } else if (cod == 0x07) {
                Wputs("il dischetto non  in formato MS-DOS");
            } else if (cod == 0x09) {
                Wputs("la stampante ha finito la carta");
            } else if (cod == 0x0a) {
                Wputs("scrittura dati non riuscita");
            } else if (cod == 0x0f) {
                Wputs("il dischetto  stato sostituito");
            } else {
                Wputs("problema non identificato");
            }
        } else {                                    /*errore non del disco*/
            Wputs(":\n\n (");
            if (cod == 0x09) {
                Wputs("la stampante ha finito la carta");
            } else if (cod == 0x02) {
                Wputs("la stampante, o altro dispositivo, non risponde");
            } else {
                Wputs("problema con un dispositivo esterno");
            }
        }

        Wputs(")\n\n Premi <Return> per ritentare l'operazione,\n"
              "       <Esc> per terminare il programma: ");
        Jclrkey();                                  /*pulisce buffer*/
        while ( (c = Jgetkey(1)) != '\r'
                && c != ESC) {                      /*input tasto <8>*/
            Jputch('\a');                           /*segnala se non valido*/
        }

        ChiudeFinestra();                           /*leva finestra errore*/
    }

    if (c == ESC) {                                 /*se deve terminare <9>*/
        Jcursor(1);                                 /*attiva cursore*/
    }
    return (c == '\r') ? ERR_RITENTA : ERR_ESCI;    /*riprova o esce <10>*/
}

/* Note su ErroreHardware:
    <1> Vedi nota 3 delle dichiarazioni.
    <2> Apre una finestra in cui mostrare il messaggio di errore. Se non
        riesce ad aprire la finestra, segnala di uscire dal programma come
        se fosse stato premuto il tasto ESC (in caso contrario, l'utente non
        avrebbe modo di sbloccare la situazione; si potrebbe, in alternativa,
        stampare sullo schermo normale invece che nella finestra).
    <3> Solo la parte bassa di cod (8 bit meno significativi) ha importanza.
    <4> Nello handler di errore  proibito scrivere con funzioni di stdio,
        ma la Wputs usa funzioni della libreria di console che accedono
        direttamente al video senza disturbare il DOS.
    <5> Il bit 15 (il pi significativo) di ax, che  una copia dell'omonimo
        registro della CPU, identifica se si tratta di un errore del disco o
        di altro dispositivo (tipicamente la stampante).
    <6> In caso di errore del disco, al (la parte bassa di ax) identifica
        il drive nel quale  avvenuto l'errore.
    <7> Il parametro cod identifica la causa precisa dell'errore, sia nel
        caso di errore del disco che di altro dispositivo. In questo secondo
        caso, un'identificazione precisa del dispositivo richiede tecniche
        pi complesse di quelle illustrate in questo corso.
    <8> In alcune situazioni, il DOS non consente di ritentare. Questo per
        si pu sapere solo col DOS 3.0 o successivo ( in alcuni bit di ax),
        e quindi non lo consideriamo in questo programma.
    <9> Se l'utente sceglie di uscire dal programma, occorre riaccendere il
        cursore in modo che non rimanga spento anche da DOS.
   <10> Le costanti sono definite all'inizio. Va sottolineato che ritentare
        con la stampante non  molto indicato: pu infatti causare la
        ripetizione di caratteri gi inviati e ricevuti dalla stampante nel
        suo buffer. Pu essere preferibile segnare l'errore in una
        variabile globale e tornare direttamente al programma con hardretn,
        anche se questa non  certamente un'operazione molto pulita (n
        sufficiente a garantire un buon esito). E' anche difficile essere
        certi che la causa dell'errore sia proprio la stampante (vedi nota 7).
*/
