/*
   Questo programma fa parte del Corso di C
   Copyright (C) 1990 Gruppo Editoriale Jackson
   Copyright (C) 2002 Enrico Colombini
   Tutti i diritti riservati
*/


/* FINESTRE: apre e richiude una serie di finestre testo */


#include <stdio.h>
#include <stdlib.h>
#include <time.h>

#include "finutil.h"
#include "Jconio.h"


#define  VLMIN  3     /*altezza minima interno finestra*/
#define  HLMIN  20    /*larghezza minima interno finestra*/
#define  VMIN   2     /*limiti minimi/massimi coordinate interno finestra*/
#define  VMAX   24
#define  HMIN   2
#define  HMAX   78


/* prototipi funzioni: */

int RandomTra(int n1, int n2);


/********************************************************************
 * main
 ********************************************************************/

main()
{
    int  n;
    int  x1,y1,x2,y2;
    char buf[80];

    Jcursor(0);                                     /*spegne cursore*/
    srand((unsigned int)time(NULL));                /*avvia random*/

    do {                                            /*apre serie finestre*/
        x1 = RandomTra(HMIN,HMAX-HLMIN+1);          /*estrae coordinate <1>*/
        x2 = RandomTra(x1+HLMIN-1,HMAX);
        y1 = RandomTra(2,VMAX-VLMIN+1);
        y2 = RandomTra(y1+VLMIN-1,VMAX);

        n = ApreFinestra(x1,y1,x2,y2);              /*crea finestra <2>*/
        if (n != 0) {                               /*se c' riuscito*/
            sprintf(buf," Aperta finestra %d\n",n); /*mette scritta <3>*/
            Wputs(buf);
        }
    } while (n != 0);                               /*finch pu <4>*/

    sprintf(buf," Premi <spazio>: ");               /*<5>*/
    Wputs(buf);
    Jclrkey();                                      /*pulisce buffer*/
    while (Jgetkey(1) != ' ')  Jputch('\a');        /*aspetta spazio*/

    do {                                            /*chiude serie finestre*/
        n = ChiudeFinestra();                       /*ne chiude una <6>*/
        if (n != 0) {                               /*se c' riuscito*/
            sprintf(buf," Chiusa finestra %d\n"
                        " Premi <spazio>: ",n+1);   /*mette scritta <7>*/
            Wputs(buf);
            while (Jgetkey(1) != ' ')  Jputch('\a');
        }
    } while (n != 0);                               /*finch pu <8>*/

    Jcursor(1);                                     /*riaccende cursore*/
}

/* Note su main:
    <1> Estrae le coordinate dell'area interna della finestra, tenendo conto
        dei limiti stabiliti come costanti (#define).
    <2> LA ApreFinestra ritorna il numero della finestra aperta, o zero
        se l'apertura non  stata possibile.
    <3> LA Wputs scrive una stringa nell'ultima finestra aperta, iniziando
        dalla posizione corrente (che per una finestra nuova  l'angolo
        in alto a sinistra).
    <4> Smette quando non  riuscito ad aprire una nuova finestra. La causa
        pu essere l'esaurimento dello stack delle finestre (array locale a
        FINUTIL.C, da non confondersi con lo stack del C), o la mancanza di
        memoria per salvare l'area video sottostante (o gli argomenti errati,
        ma qui non pu succedere). In questo programma possono capitare
        entrambe: se le finestre sono ampie, la memoria finisce prima dello
        stack delle finestre. Sono infatti disponibili soltanto alcune decine
        di Kbyte (la lezione E7 tratta i limiti di memoria di MS-DOS).
    <5> Poich l'ultima apertura di finestra  fallita, questa scritta appare
        nell'ultima finestra aperta in precedenza.
    <6> Le finestre sono chiuse in ordine inverso a quello di apertura:
        viene chiusa per prima la finestra corrente, cio l'ultima aperta.
        Il valore ritornato  il numero della nuova finestra corrente, o zero
        se sono tutte chiuse.
    <7> Ogni \n nella stringa manda a capo all'interno della finestra stessa.
    <8> Smette quando non ci sono pi finestre da chiudere.
*/


/********************************************************************
 * RandomTra: estrae numero casuale compreso tra n1 e n2, inclusi.
 ********************************************************************/

int RandomTra(int n1, int n2)
{
    return rand()%(n2-n1+1)+n1;     /*<1>*/
}

/* Note su RandomTra:
    <1> Il risultato  ragionevolmente casuale solo per valori relativamente
        piccoli di n1 e n2.
*/
