/*
   Questo programma fa parte del Corso di C
   Copyright (C) 1990 Gruppo Editoriale Jackson
   Copyright (C) 2002 Enrico Colombini
   Tutti i diritti riservati
*/


/* INVERTE: inverte l'ordine degli elementi di un array */


#include <stdio.h>


int  InputDati(int d[], int dMax, int mi, int ma);      /*prototipi funzioni*/
void InverteDati(int d[], int n);
void StampaDati(int d[], int n);
void Scambia(int *pa, int *pb);
int  InputInt(int mi, int ma);


#define MAXDATI 8       /*numero massimo dati (dimensione dell'array)*/
#define VALMIN  -800    /*valore minimo ammesso*/
#define VALMAX  800     /*valore massimo ammesso*/


main()
{
    int val[MAXDATI];       /*array contenente MAXDATI interi*/
    int nVal;               /*numero dati contenuti nell'array*/

    printf("\n Inversione dell'ordine dei dati:\n\n");

    nVal = InputDati(val,MAXDATI,VALMIN,VALMAX);    /*input dati <1>*/

    printf("\nHai inserito i dati in quest'ordine:\n\n");
    StampaDati(val,nVal);                           /*ordine attuale <2>*/

    InverteDati(val,nVal);                          /*inversione <3>*/

    printf("\nMa io li preferisco al contrario:\n\n");
    StampaDati(val,nVal);                           /*ordine finale*/
}

/*  Note su main:
    <1> La InputDati scriver i valori introdotti dall'utente negli elementi
        dell'array val[]. Per passare un array basta indicarne il nome, e non
        si deve usare il simbolo di indirizzo &. Il nome di un array 
        infatti l'indirizzo del suo primo elemento: passare val  lo stesso
        che passare &val[0]. Dato che si passa l'indirizzo dell'array e non
        il suo valore (che implicherebbe di farne una copia), ogni modifica
        all'array ricevuto dalla funzione ha effetto sull'array originale
        passato nella chiamata.
    <2> Anche qui scrivere val  come scrivere &val[0], cio l'indirizzo
        del primo elemento di val[].
    <3> La InverteDati modifica il contenuto dell'array val[].
*/


/********************************************************************
 * InputDati: input da 2 a dMax dati compresi tra mi e ma
 *            nell'array d[], ritorna il numero di dati introdotti.
 ********************************************************************/

int InputDati(int d[], int dMax, int mi, int ma)        /*<1>*/
{
    int n;      /*numero dati*/
    int i;

    printf("Quanti dati vuoi introdurre (%d-%d)? ",2,dMax);
    n = InputInt(2,dMax);                           /*input n. valori*/
    putchar('\n');                                  /*a capo*/

    for (i = 0; i < n; i++) {                       /*input nell'array*/
        printf("Dato numero %d: ",i+1);             /*<2>*/
        d[i] = InputInt(mi,ma);                     /*legge num. pos. <3>*/
    }
    return n;                                       /*numero dati*/
}

/*  Note su InputDati:
    <1> Il parametro d[]  un array di int, o pi precisamente d  un
        pointer al primo elemento di un array di int. La funzione chiamante
        ha infatti passato l'indirizzo del primo elemento (vedi main, nota 1).
        Dal punto di vista pratico, d[] si usa come un normale array. Si
        tratta per sempre dello stesso array, non di una copia locale: 
        ancora l'array val[] del main visto con un altro nome. Ogni modifica
        a d[]  una modifica a val[]: gli array sono passati per riferimento.
    <2> Gli elementi dell'array partono da zero, mentre qui vogliamo
        numerarli a partire da uno, quindi i+1.
    <3> Il valore ritornato da InputInt viene messo in effetti nell'array
        val[] del main, che la InputDati vede localmente con il nome d[].
*/


/********************************************************************
 * InverteDati: inverte l'ordine dei primi n elementi dell'array d[].
 ********************************************************************/

void InverteDati(int d[], int n)        /*<1>*/
{
    int i,j;

    i = 0;                                          /*d[i] = primo dato*/
    j = n-1;                                        /*d[j] = ultimo dato*/
    while (j > i) {
        Scambia(&d[i],&d[j]);                       /*scambia d[i],d[j] <2>*/
        i++;                                        /*passa ai prossimi*/
        j--;
    }
}

/*  Note su InverteDati:
    <1> Come per la InputDati, d[]  sempre val[] (vedi nota 3 di main).
    <2> d[]  un array di int, il suo elemento d[i]  un int, quindi &d[i]
         l'indirizzo di un int. La funzione Scambia riceve quindi gli
        indirizzi di due variabili int (che in questo caso sono elementi
        dell'array d[]). Attraverso questi indirizzi potr modificare le
        variabili.
*/


/********************************************************************
 * StampaDati: mostra i primi n elementi dell'array d[], numerati da 1.
 ********************************************************************/

void StampaDati(int d[], int n)     /*<1>*/
{
    int i;

    for (i = 0; i < n; i++) {
        printf(" %d)  %d\n",i+1,d[i]);
    }
}

/*  Note su StampaDati:
    <1> Come per InputDati e InverteDati, d[]  in realt val[] di main.
*/


/********************************************************************
 * Scambia: scambia il contenuto delle variabili puntate da pa e pb.
 ********************************************************************/

void Scambia(int *pa, int *pb)      /*<1>*/
{
    int c;

    c = *pa;                                        /*<2>*/
    *pa = *pb;
    *pb = c;
}

/*  Note su Scambia:
    <1> pa e pb sono due pointer ad int, che nella chiamata ricevono gli
        indirizzi delle due variabili da scambiare.
    <2> Scrivere *pa  come indirizzare la variabile indicata come primo
        argomento nella chiamata, cio la d[i] di InverteDati (nota 2),
        mentre *pb corrisponde alla d[j] della stessa InverteDati. Questa
        funzione scambia quindi il contenuto di d[i] con quello di d[j]
        (dato che d[] della InverteDati non  altro che val[] del main,
        sono in realt scambiati due elementi di val[]). Quanto descritto
         quello che avviene in questo programma, ma la Scambia non deve
        saperlo: si limita a scambiare il contenuto delle due variabili di
        cui riceve gli indirizzi (in pratica, l'uso di una funzione separata
        per scambiare due variabili  poco efficiente e si tende ad evitarlo).
*/


/********************************************************************
 * InputInt: input di intero compreso tra mi e ma, ritorna il valore
 *           introdotto, ripete l'input se il valore non  valido.
 ********************************************************************/

int InputInt(int mi, int ma)        /*<1>*/
{
    int num;        /*numero introdotto*/
    int risulta;    /*risultato della scanf*/
    int valido;     /*flag di numero valido*/

    do {
        risulta = scanf("%d",&num);                 /*legge numero*/
        if (risulta != EOF) {                       /*ripulisce se non EOF*/
            while (getchar() != '\n')
                ;
        }
        valido = (risulta == 1 && num >= mi
                  && num <= ma);                    /*controlla se ok*/
        if (! valido) {                             /*segnala errore*/
            printf("Devi introdurre un intero"
                   " compreso tra %d e %d: \a",mi,ma);
        }
    } while (! valido);                             /*ripete se non ok*/

    return num;                                     /*ritorna valore*/
}

/*  Note su InputInt:
    <1> InputInt  commentata nel programma RETTANG della lezione B5.
*/
