/*
   Questo file fa parte del Corso di C
   Copyright (C) 1990 Gruppo Editoriale Jackson
   Copyright (C) 2002 Enrico Colombini
   Tutti i diritti riservati
*/


/* JCONIO.H: header per la libreria di console Jackson, */
/*           sia per Turbo C 2.0 che per Quick C 2.0.   */
/*           Versione E6: aggiunte Jgettext, Jputtext.  */


#if     !defined(__JCONIO_H_)       /*include solo se non gi incluso*/
#define __JCONIO_H_


/****************** Prototipi delle funzioni di output *******************/

void Jtexttcolor(int col);          /*Sceglie il colore di foreground*/
void Jtextback(int col);            /*Sceglie il colore di background*/
int  Jgettextcolor(void);           /*Ritorna il colore di foreground*/
int  Jgettextback(void);            /*Ritorna il colore di background*/
void Jclrscr(void);                 /*Cancella al colore di background*/
void Jgotoxy(int x,int y);          /*Sposta il cursore alla posizione x,y*/
void Jputch(int c);                 /*Stampa il carattere c*/
void Jputs(char *s);                /*Stampa la stringa s, non va a capo*/
void Jcursor(int vis);              /*Spegne cursore (0) o riaccende (1)*/
int  Jposx(void);                   /*Ritorna la colonna corrente*/
int  Jposy(void);                   /*Ritorna la linea corrente*/

/* Note:
    - La Jputs si comporta in modo diverso tra Turbo C e Quick C quando
      incontra un newline (\n). Per evitare problemi, usare sempre la
      combinazione \r\n (CRLF) per andare a capo. Inoltre la Jputs non
      aggiunge alcun \n dopo la stampa della stringa.
    - Non  fornita un'equivalente della printf, per la difficolt di
      realizzarla con il Quick C. Bisogna stampare in una stringa con la
      sprintf, e poi stampare la stringa con la Jputs.


/******************* Prototipi delle funzioni di input *******************/

int  Jgetkey(int cur);              /*Legge ogni tasto, mostra cursore se 1*/
void Jclrkey(void);                 /*Cancella il buffer di tastiera*/


/*********** Prototipi delle funzioni di copiatura area video ************/

void Jgettext(int x1,int y1,int x2,int y2, char *p);    /*Legge area video*/
void Jputtext(int x1,int y1,int x2,int y2, char *p);    /*Scrive area video*/


/*************************************************************************/


#include <conio.h>                          /*usa librerie di console*/


/********************************************************************
 * Per il Turbo C 2.0 la maggior parte delle funzioni desiderate sono
 * gi disponibili nella libreria di console: basta cambiare i nomi.
 ********************************************************************/

#ifdef __TURBOC__                           /*compila se Turbo C*/

  #define Jtextcolor    textcolor           /*definisce equivalenze nomi*/
  #define Jtextback     textbackground
  #define Jclrscr       clrscr
  #define Jgotoxy       gotoxy
  #define Jputch        putch
  #define Jputs         cputs
  #define Jposx         wherex
  #define Jposy         wherey
  #define Jgettext      gettext
  #define Jputtext      puttext

  /*le funzioni Jgettextcolor e Jgettextback sono definite in Jconio.c*/


/********************************************************************
 * Per il Quick C 2.0 serve molto pi lavoro, per costruire quello
 * che manca e semplificare l'uso di quello che c'. L'uso della
 * libreria <graph> imposto dalla Microsoft comporta una notevole
 * inefficienza in termini di spazio quando si vuole usare solamente
 * il video alfanumerico.
 ********************************************************************/

#else                                       /*compila se Quick C*/

  #include <graph.h>                        /*usa la libreria grafica*/

  #define BLACK             0               /*nomi dei colori in modo testo*/
  #define BLUE              1
  #define GREEN             2
  #define CYAN              3
  #define RED               4
  #define MAGENTA           5
  #define BROWN             6
  #define LIGHTGRAY         7
  #define DARKGRAY          8
  #define LIGHTBLUE         9
  #define LIGHTGREEN        10
  #define LIGHTCYAN         11
  #define LIGHTRED          12
  #define LIGHTMAGENTA      13
  #define YELLOW            14
  #define WHITE             15

  #define BLINK             16              /*aggiungere per il lampeggio*/

  /* macro per sfruttare funzioni fornite nella libreria del Quick C 2.0: */

  #define Jtextcolor(col)  ((void)_settextcolor(col))
  #define Jtextback(col)   ((void)_setbkcolor((long)(col)))
  #define Jgettextcolor()  ((int)(_gettextcolor()))
  #define Jgettextback()   ((int)(_getbkcolor()))
  #define Jclrscr()        _clearscreen(_GCLEARSCREEN)
  #define Jgotoxy(x,y)     ((void) _settextposition(y,x));
  #define Jputs            _outtext

  /*le funzioni Jputch, Jposx, Jposy, Jgettext, Jputtext
    sono definite in Jconio.c.
  */


#endif                                      /*fine scelta Turbo C / Quick C*/


/*le funzioni Jcursor, Jgetkey e Jclrkey sono definite in Jconio.c*/


#endif                                      /*(se non gi incluso)*/
