/*
   Questo file fa parte del Corso di C
   Copyright (C) 1990 Gruppo Editoriale Jackson
   Copyright (C) 2002 Enrico Colombini
   Tutti i diritti riservati
*/


/* JDIRECT.H: header per usare le funzioni di ricerca nelle     */
/*            directory MS-DOS sia col Quick C che col Turbo C. */


#if     !defined(__JDIRECT_H_)      /*include solo se non gi incluso*/
#define __JDIRECT_H_


#include <dos.h>

typedef struct {                    /*definisce il tipo FileInfo: <1> */
    char reserved[21];              /*spazio riservato per il DOS*/
    char attrib;                    /*attributi del file*/
    struct {                        /*tempo dell'ultima modifica <2>*/
        unsigned int sec   : 5;
        unsigned int min   : 6;
        unsigned int hours : 5;
    } time;
    struct {                        /*data dell'ultima modifica <3>*/
        unsigned int day   : 5;
        unsigned int month : 4;
        unsigned int year  : 7;
    } date;
    long size;                      /*dimensioni del file*/
    char name[13];                  /*nome del file*/
} FileInfo;


#ifdef __TURBOC__                   /*compila se Turbo C*/

  #include <dir.h>

  #define  FA_NORMAL  0             /*costante per file 'normali'*/

  /*converte il tipo del pointer a dati file: */

  #define  findfirst(p,b,a)  findfirst(p,(struct ffblk *)b,a)       /*<4>*/
  #define  findnext(b)       findnext((struct ffblk *)b)

#else                               /*compila se Quick C*/

  #include <direct.h>

  #define  FA_NORMAL  _A_NORMAL     /*converte nomi costanti attributi: */
  #define  FA_RDONLY  _A_RDONLY     /*sola lettura*/
  #define  FA_HIDDEN  _A_HIDDEN     /*nascosto*/
  #define  FA_SYSTEM  _A_SYSTEM     /*di sistema*/
  #define  FA_LABEL   _A_VOLID      /*etichetta di volume*/
  #define  FA_DIREC   _A_SUBDIR     /*directory*/
  #define  FA_ARCH    _A_ARCH       /*archivio*/

  /*converte nomi funzioni, cambia ordine argomenti di findfirst: */

  #define  findfirst(p,b,a)  (int)_dos_findfirst(p,a,(struct find_t *)b)
  #define  findnext(b)       (int)_dos_findnext((struct find_t *)b)  /*<5>*/

#endif                              /*fine scelta Turbo C / Quick C*/


#endif                              /*(se non gi incluso)*/


/* Note su DIRECT.H:

    <1> FileInfo  una struttura che contiene  le informazioni relative ad
        un file, restituite da findfirst e findnext.
    <2> La componente time  un int (16 bit) che contiene in realt tre
        valori, ciascuno conservato in un gruppo di bit adiacenti. L'ordine
        di lettura dei bit dipende dal compilatore, quindi questa definizione
        non  portatile (anche se va sia col Turbo C che col Quick C). Si
        potevano anche scrivere semplicemente i tre bit field come componenti
        della struttura FileInfo (senza usare la struttura time), ma abbiamo
        preferito sottolineare che i tre bit field formano complessivamente
        un int: questo pu essere utile per comodit di manipolazione (es.
        passare time ad una funzione).
    <3> Vedi nota 2.
    <4> Questo cast, purtroppo, toglie al compilatore ogni possibilit di
        controllo di errore. L'abbiamo usato solo per assicurare la
        portatilit tra il Turbo C 2.0 ed il Quick C 2.0.
    <5> Vedi nota 4.
*/
