/*
   Questo programma fa parte del Corso di C
   Copyright (C) 1990 Gruppo Editoriale Jackson
   Copyright (C) 2002 Enrico Colombini
   Tutti i diritti riservati
*/


/* PARIDISP: suddivide i numeri in pari e dispari */


#include <stdio.h>
#include <limits.h>     /*<1>*/


int  InputInt(int mi, int ma);      /*prototipi delle funzioni usate*/


main()
{
    enum { MAXDATI = 10 };  /*numero massimo valori <2>*/

    int val[MAXDATI];       /*array contenente MAXDATI interi <3>*/
    int nVal;               /*numero dati nell'array*/
    int i,n;

    printf("\n Suddivisione dei numeri in pari e dispari:\n\n");

    printf("Quanti numeri vuoi introdurre (%d-%d)? ",1,MAXDATI);
    nVal = InputInt(1,MAXDATI);                     /*input n. valori <4>*/
    putchar('\n');                                  /*a capo*/

    for (i = 0; i < nVal; i++) {                    /*scandisce l'array <5>*/
        printf("Numero %d: ",i+1);                  /*<6>*/
        val[i] = InputInt(0,INT_MAX/10);            /*input valore <7>*/
    }

    printf("\nHai introdotto i seguenti numeri pari:\n\n ");
    n = 0;                                          /*azzera contatore*/
    for (i = 0; i < nVal; i++) {
        if (val[i]%2 == 0) {                        /*<8>*/
            if (n > 0)  printf(", ");               /*separatore*/
            printf("%d",val[i]);                    /*e numero*/
            n++;                                    /*lo conta*/
        }
    }
    if (n == 0)  printf("Nessuno.");
    putchar('\n');

    printf("\nHai introdotto i seguenti numeri dispari:\n\n ");
    n = 0;                                          /*azzera contatore*/
    for (i = 0; i < nVal; i++) {
        if (val[i]%2 == 1) {
            if (n > 0)  printf(", ");               /*separatore*/
            printf("%d",val[i]);                    /*e numero*/
            n++;                                    /*lo conta*/
        }
    }
    if (n == 0)  printf("Nessuno.");
    putchar('\n');
}

/*  Note su main:
    <1> Lo header <limits.h> contiene la definizione di INT_MAX, il
        massimo valore assegnabile ad un int.
    <2> Si potrebbe anche scrivere: #define MAXDATI 10. In questo caso la
        costante MAXDATI non sarebbe limitata alla main, ma accessibile da
        tutto il programma. Scrivendo invece: const int maxDati = 10, si
        occuperebbe memoria inutilmente.
    <3> Questa linea dichiara un array val[] di MAXDATI elementi. Il primo
        elemento  val[0], l'ultimo  val[MAXDATI-1]. L'elemento val[MAXDATI]
        non esiste, a differenza del BASIC. Il numero indicato tra quadre 
        quindi il numero totale di elementi dell'array, non l'indice
        dell'ultimo elemento. Notare l'uso della costante MAXDATI invece del
        numero 10, per facilit di lettura e modifica.
    <4> Se l'array fosse stato dichiarato con: int val[10], invece di usare
        la costante MAXDATI, sarebbe pi difficile trovare e modificare tutti
        i riferimenti al numero di elementi contenuti, come in questa linea
        e nella precedente. Notare che il limite di MAXVAL nell'input di nVal
        assicura che nel resto del programma non venga usato un elemento
        inesistente (oltre la fine dell'array).
    <5> Questo  il tipico ciclo che accede agli elementi di un array: da
        zero (incluso) alla dimensione dell'array (esclusa). In questo caso
        nVal non  la dimensione dell'array, ma il numero di elementi usati.
        I valori introdotti dall'utente sono memorizzati negli elementi
        dell'array, che verr in seguito scandito per stampare solo i numeri
        pari, e poi nuovamente per stampare solo i numeri dispari.
    <6> Il primo elemento ha indice zero, ma vogliamo mostrarlo come numero
        uno, dunque i+1.
    <7> Il valore ritornato dalla InputInt viene assegnato all'elemento i
        dell'array val[]. Il limite positivo scelto  del tutto arbitrario.
    <8> Un numero  pari se diviso per due d resto zero (l'operatore % d
        il resto della divisione).
*/


/********************************************************************
 * InputInt: input di intero compreso tra mi e ma, ritorna il valore
 *           introdotto, ripete l'input se il valore non  valido.
 ********************************************************************/

int InputInt(int mi, int ma)        /*<1>*/
{
    int num;        /*numero introdotto*/
    int risulta;    /*risultato della scanf*/
    int valido;     /*flag di numero valido*/

    do {
        risulta = scanf("%d",&num);                 /*legge numero*/
        if (risulta != EOF) {                       /*ripulisce se non EOF*/
            while (getchar() != '\n')
                ;
        }
        valido = (risulta == 1 && num >= mi
                  && num <= ma);                    /*controlla se ok*/
        if (! valido) {                             /*segnala errore*/
            printf("Devi introdurre un intero"
                   " compreso tra %d e %d: \a",mi,ma);
        }
    } while (! valido);                             /*ripete se non ok*/

    return num;                                     /*ritorna valore*/
}

/*  Note su InputInt:
    <1> InputInt  commentata nel programma RETTANG della lezione B5.
*/
