/*
   Questo programma fa parte del Corso di C
   Copyright (C) 1990 Gruppo Editoriale Jackson
   Copyright (C) 2002 Enrico Colombini
   Tutti i diritti riservati
*/


/* PRIMI: trova i numeri primi con il crivello di Eratostene */


#include <stdio.h>


void TrovaPrimi(int n[], int maxn);                 /*prototipi funzioni*/
int  ChiedeLimiti(int *p1, int *p2, int maxn);
void StampaPrimi(int *p1, int *p2);
int  InputInt(int mi, int ma);


#define MAXNUM 10000        /*limite della ricerca di numeri primi*/
#define MAXPOS 70           /*ultima posizione di stampa numeri*/

int primi[MAXNUM];          /*per ogni numero, 1 se primo <1>*/


main()
{
    int da,a;       /*limiti dei primi da stampare*/
    int i,n,r;

    printf("\n Numeri primi, con il crivello di Eratostene:\n\n");

    TrovaPrimi(primi,MAXNUM);                       /*segna i num. primi <2>*/

    while (ChiedeLimiti(&da,&a,MAXNUM-1)) {         /*quali mostrare? <3>*/
        StampaPrimi(primi+da,primi+a);              /*passa una parte <4>*/
    }
}

/* Note su main:
    <1> Questo array dovrebbe essere dichiarato nella main, che  l'unica
        funzione ad usarlo. Alcuni compilatori hanno per problemi con
        array locali di grandi dimensioni, e quindi primi[]  dichiarato
        globale (cio esterno ad ogni funzione).
    <2> Scrivere primi  come scrivere &primi[0]: l'array primi[]  passato
        per riferimento alla funzione TrovaPrimi, che pu modificarlo.
    <3> Dato che la ChiedeLimiti ritorna pi di un valore, sono passati
        gli indirizzi delle due variabili (da,a) dove mettere i valori
        introdotti dall'utente. Il limite  MAXNUM-1, perch l'elemento
        MAXNUM di primi[] non esiste.
    <4> Scrivere primi+da  come scrivere &primi[da], cio passare l'indirizzo
        dell'elemento da dell'array primi. La funzione chiamata potr usarlo
        come un array (il cui elemento zero corrisponder all'elemento da
        dell'array primi[]), o metterlo in un pointer (come in questo caso).
*/


/********************************************************************
 * TrovaPrimi: trova i numeri primi tra 2 e maxn, usando il crivello
 *             di Eratostene nell'array n[] di maxn elementi. Ogni
 *             elemento contiene il suo indice se primo, 0 se no.
 ********************************************************************/

void TrovaPrimi(int n[], int maxn)      /*<1>*/
{
    int i,mu;

    printf("un attimo di pazienza...");

    for (i = 2; i < maxn; i++) {                    /*numera elementi <2>*/
        n[i] = i;
    }

    for (i = 2; i < maxn; i++) {                    /*ciclo di ricerca <3>*/
        if (n[i]) {                                 /*trovato un primo*/
            for (mu = i+i; mu < maxn; mu += i) {    /*elimina i multipli*/
                n[mu] = 0;
            }
        }
    }

    printf("\n\n");
}

/*  Note su TrovaPrimi:
    <1> La funzione lavora sui primi maxn elementi dell'array n[].
    <2> In ciascun elemento di n[], a partire dal 2 (gli elementi 0 e 1 non
        sono usati) viene scritto il corrispondente indice: n[2] contiene 2,
        n[3] contiene 3, ecc. Questo servir nella StampaPrimi, che non 
        in grado di conoscere l'indice degli elementi in primi[], in quanto
        riceve solo una parte dell'array.
    <3> L'algoritmo del crivello di Eratostene funziona in questo modo: si
        fanno passare gli elementi a partire dal 2. Se il contenuto non 
        zero, il numero  primo e viene lasciato inalterato; vengono per
        messi a zero tutti i suoi multipli, che evidentemente non possono
        essere primi. Una volta scandito tutto l'array, rimangono solamente
        i numeri primi; tutti gli altri sono a zero.
*/


/********************************************************************
 * ChiedeLimiti: chiede i limiti dei numeri primi da mostrare, che
 *               devono esser compresi tra 2 e maxn, li mette in
 *               *p1 e *p2, torna 1 (vero) se *p2 > *p1.
 ********************************************************************/

int ChiedeLimiti(int *p1, int *p2, int maxn)        /*<1>*/
{
    int i,mu;

    printf("Mostro i numeri primi a partire da   : ");
    *p1 = InputInt(2,maxn);
    printf("Fino a (uguale a prima per smettere) : ");
    *p2 = InputInt(2,maxn);

    return (*p2 > *p1);                             /*vero se non smette <2>*/
}

/*  Note su ChiedeLimiti:
    <1> I valori introdotti sono messi nella variabili puntate da p1 e p2
        (vedi nota 3 di main).
    <2> Questo  un normale confronto tra due variabili int.
*/


/********************************************************************
 * StampaPrimi: mostra i numeri primi da *p1 a *p2, stampando solo
 *              gli elementi che non contengono zero.
 ********************************************************************/

void StampaPrimi(int *p1, int *p2)      /*<1>*/
{
    int pos = 0;    /*posizione corrente di stampa*/
    int *p;         /*pointer di lavoro <2>*/

    putchar('\n');

    for (p = p1; p <= p2; p++) {                    /*<3>*/
        if (*p) {                                   /*stampa se primo <4>*/
            if (pos > MAXPOS) {                     /*a capo se in fondo <5>*/
                putchar('\n');
                pos = 0;
            } else if (pos > 0) {
                printf(", ");                       /*stacca*/
                pos += 2;
            }
            pos += printf("%d",*p);                 /*stampa <6>*/
        }
    }

    printf("\n\n");
}

/*  Note su StampaPrimi:
    <1> StampaPrimi riceve due indirizzi, che sono messi nei pointer p1 e p2.
        Questi indirizzi devono riferirsi ad elementi dello stesso array, ed
        infatti main passa a StampaPrimi gli indirizzi del primo e
        dell'ultimo elemento dell'array primi[] che devono essere stampati.
        Dato che primi[]  un array di int, dei pointer contenenti indirizzi
        di suoi elementi sono dei pointer a int.
        Passando l'array con il sistema tradizionale, sarebbero invece stati
        necessari tre parametri: l'array stesso ed i due elementi limite.
    <2> La variabile di lavoro p  un pointer a int (la dichiarazione dice
        infatti che *p  un int), e pu quindi contenere l'indirizzo di
        una variabile int. p, p1 e p2 sono dello stesso tipo e quindi le
        assegnazioni tra l'una e l'altra sono possibili.
    <3> In questo ciclo, il pointer p varia tra p1 e p2. Questo  possibile
        solo se p, p1 e p2 sono dello stesso tipo (pointer a int), ed ha
        senso solo se p1 e p2 puntano a (contengono l'indirizzo di) elementi
        di uno stesso array. In pratica, p scorre lungo l'array, contenendo
        ad ogni ciclo l'indirizzo di un successivo elemento.
    <4> if (*p) significa: if (*p != 0), ed in questo caso significa: se
        l'elemento puntato da p contiene un numero primo (in caso contrario
        la TrovaPrimi vi ha scritto zero).
    <5> Queste linee servono per andare a capo prima di arrivare al bordo
        del video, ed a separare i numeri con virgole (ma senza aggiungere
        una virgola dopo l'ultimo). MAXPOS non  l'ultima colonna usabile
        del video, ma l'ultima alla quale  ammesso iniziare la stampa di
        un numero.
    <6> *p  il numero primo contenuto nell'elemento puntato da p. Il numero
        corrisponde all'indice dell'elemento stesso in primi[] (vedi nota 2
        di TrovaPrimi), ma dato che la StampaPrimi non riceve l'array primi[]
        non potrebbe conoscere l'indice dell'elemento che sta leggendo. Il
        numero  quindi stato scritto nell'elemento corrispondente, invece
        di marcarlo semplicemente con 1 (primo) o zero (non primo) come nella
        forma classica di questo algoritmo.
*/


/********************************************************************
 * InputInt: input di intero compreso tra mi e ma, ritorna il valore
 *           introdotto, ripete l'input se il valore non  valido.
 ********************************************************************/

int InputInt(int mi, int ma)        /*<1>*/
{
    int num;        /*numero introdotto*/
    int risulta;    /*risultato della scanf*/
    int valido;     /*flag di numero valido*/

    do {
        risulta = scanf("%d",&num);                 /*legge numero*/
        if (risulta != EOF) {                       /*ripulisce se non EOF*/
            while (getchar() != '\n')
                ;
        }
        valido = (risulta == 1 && num >= mi
                  && num <= ma);                    /*controlla se ok*/
        if (! valido) {                             /*segnala errore*/
            printf("Devi introdurre un intero"
                   " compreso tra %d e %d: \a",mi,ma);
        }
    } while (! valido);                             /*ripete se non ok*/

    return num;                                     /*ritorna valore*/
}

/*  Note su InputInt:
    <1> InputInt  commentata nel programma RETTANG della lezione B5.
*/
