/*
   Questo programma fa parte del Corso di C
   Copyright (C) 1990 Gruppo Editoriale Jackson
   Copyright (C) 2002 Enrico Colombini
   Tutti i diritti riservati
*/


/* SPAZIO: mostra lo spazio libero sul disco corrente */


#include <stdio.h>
#include <ctype.h>
#include <dos.h>        /*per chiamate a DOS*/


/********************************************************************
 * main
 ********************************************************************/

main(int argc, char *argv[])
{
    int   drive;       /*drive da esaminare (0=A:, 1=B:, ecc.)*/
    union REGS r;      /*registri per chiamata DOS*/
    int   ctot;        /*numero totale cluster nel disco <1>*/
    int   clib;        /*numero di cluster liberi*/
    int   scl;         /*numero di settori per cluster*/
    long  bcl;         /*numero di byte per cluster*/
    long  btot;        /*numero di byte totali <2>*/
    long  blib;        /*numero di byte liberi*/

    putchar('\n');
    if (argc > 2) {                                 /*test argomenti <3>*/
        puts("- Uso: spazio [drive]\n");            /*errore*/
    } else  {
        if (argc == 2) {                            /*indica un drive*/
            drive = toupper(argv[1][0])-'A';        /*numero drive <4>*/
        } else {                                    /*drive non indicato*/
            drive = bdos(0x19,0,0);                 /*usa corrente <5>*/
        }

        r.h.ah = 0x36;                              /*Get Disk Free Space*/
        r.h.dl = drive+1;
        intdos(&r,&r);                              /*chiama il DOS <6>*/

        if (r.x.ax == 0xffff) {                     /*controlla <7>*/
            printf("%c: non  un drive valido.\n",
                   'A'+drive);
        } else {                                    /*<8>*/
            scl = r.x.ax;                           /*settori per cluster*/
            bcl = (long)scl*r.x.cx;                 /*byte per cluster*/
            ctot = r.x.dx;                          /*totale cluster*/
            clib = r.x.bx;                          /*cluster liberi*/

            printf("Spazio disponibile sul drive %c:\n\n"
                   "  %d cluster = %d settori = %ld byte"
                   " (su %ld totali).\n",
                   'A'+drive,clib,clib*scl,
                   (long)clib*bcl,(long)ctot*bcl);
        }
    }
}

/* Note su main:
    <1> Ogni cluster comprende un gruppo di scl settori, ciascuno
        dei quali contiene un certo numero di byte.
    <2> Un int non  evidentemente sufficiente per il numero di byte che
        un disco pu contenere.
    <3> Se gli argomenti sono in numero errato, stampa le istruzioni in
        forma sintetica.
    <4> Se c' un argomento, il primo carattere  considerato la lettera
        indicante il drive contenente il disco da esaminare. Ad esempio,
        scrivendo A: si sceglie il drive 0.
    <5> La funzione DOS che ritorna lo spazio libero su disco pu anche
        essere chiamata indicando di esaminare il drive corrente, ma in
        questo caso non potremmo ristampare la lettera che identifica il
        drive. La chiediamo quindi con una funzione DOS. Dato che basta il
        valore del registro ah, usiamo la semplice bdos. Non sono richiesti
        valori nei registri dx e al, perci passiamo degli zeri.
    <6> Qui la bdos non basta: vengono ritornati valori in quattro registri.
        Usiamo quindi la intdos, passando e ricevendo i valori con una
        variabile di tipo union REGS (come con il BIOS).
    <7> Se il drive indicato non  valido (es. Z:), ax contiene ffffh.
    <8> Non ci sono stati errori: i registri contengono i valori desiderati.
*/
