/*
   Questo programma fa parte del Corso di C
   Copyright (C) 1990 Gruppo Editoriale Jackson
   Copyright (C) 2002 Enrico Colombini
   Tutti i diritti riservati
*/


/* RIPETE: ripete una parola per il numero di volte indicato */


#include <stdio.h>
#include <string.h>     /*<1>*/
#include <ctype.h>


void InputDati(int *np, char *par, int rmin, int rmax); /*prototipi funzioni*/
void RipeteParola(int n, char *par);


#define MAXLEN 128       /*lunghezza massima di una stringa introdotta*/
#define RIPMAX 500       /*numero massimo di ripetizioni*/
#define LIMITE 78        /*colonna limite a cui stampare*/


main()
{
    char parola[MAXLEN+1];  /*parola da ripetere <2>*/
    int  nrip;              /*numero di ripetizioni*/
    int  i;

    printf("\n Ripetizione di una parola:\n\n");

    InputDati(&nrip,parola,1,RIPMAX);               /*<3>*/

    RipeteParola(nrip,parola);
}

/*  Note su main:
    <1> Lo header <string.h>  richiesto per l'uso delle funzioni stringa,
        ad esempio strlen.
    <2> Come sempre, l'elemento (carattere) in pi serve per lo zero finale.
    <3> nrip  passata per riferimento (indirizzo), in modo che la funzione
        InputDati possa modificarne il contenuto. Anche la stringa parola
         passata per riferimento, ma non serve indicare & perch si tratta
        di un array e quindi il suo nome  gi l'indirizzo del suo primo
        elemento.
*/


/********************************************************************
 * InputDati: input numero di ripetizioni (compreso tra rmin e rmax)
 *            in *np, parola da ripetere in *par.
 ********************************************************************/

void InputDati(int *np, char *par, int rmin, int rmax)     /*<1>*/
{
    char buf[128];      /*buffer di linea <2>*/
    int  ok;            /*flag di stringa valida*/

    do {
        do {                                              /*legge stringa*/
            printf("Numero di ripetizioni e parola da ripetere: ");
            ok = (gets(buf) != NULL && strlen(buf) > 0);  /*<3>*/
            if (! ok)  putchar('\a');
        } while (! ok);                                   /*esce con ok vero*/

        if (sscanf(buf,"%d %s",np,par) != 2) {            /*<4>*/
            puts("\n- Devi indicare un numero seguito da una parola"
                 " (es. 14 Ciao).\n\a");
            ok = 0;
        } else if (*np < rmin || *np > rmax) {            /*<5>*/
            printf("\n- Il numero di ripetizioni dev'essere"
                   " compreso tra %d e %d.\n\n\a",rmin,rmax);
            ok = 0;
        }

    } while (! ok);                                       /*ripete se non ok*/
}

/*  Note su InputDati:
    <1> La funzione riceve l'indirizzo di un int nel pointer np, l'indirizzo
        di un char nel pointer par, e due valori int in rmin e rmax. E' utile
        confrontare con la chiamata (nota 2 di main).
    <2> Un buffer  un'area di memoria usata per accumulo temporaneo, in
        questo caso dei caratteri della linea introdotta. Nei computer MS-DOS
        la gets non legge mai pi di 127 caratteri (pi lo zero finale).
    <3> Va tutto bene se la gets non ritorna NULL e la stringa introdotta
        non  nulla. E' importante notare che se l'utente batte F6 o Ctrl-Z
        la gets ritorna NULL e il contenuto del buffer buf[]  indefinito:
        la strlen non avrebbe senso. Fortunatamente il C non esegue il
        secondo test se il primo  falso (nel caso di &&).
    <4> La sscanf legge dalla stringa buf[] invece che dalla tastiera. Deve
        trovare un numero decimale seguito da una stringa. Poich la sscanf
        ritorna il numero di elementi correttamente letti, basta confrontare
        il valore ritornato con 2 per sapere se la sintassi era corretta.
        Non c' il simbolo di indirizzo (&) davanti ad np perch np  un
        pointer, e quindi contiene gi un indirizzo. Non c' davanti a par
        perch par  un nome di array, e quindi  pure un indirizzo.
    <5> np  un pointer, *np  la variabile a cui np punta, cio quella in
        cui la sscanf ha letto il valore introdotto.
*/


/********************************************************************
 * RipeteParola: ripete n volte la parola par, con virgole separatrici
                 e a capo corretti.
 ********************************************************************/

void RipeteParola(int n, char *par)
{
    int col;    /*colonna corrente di stampa*/
    int i,lp;

    lp = strlen(par);                               /*lunghezza parola*/
    col = 0;

    putchar('\n');
    for (i = 0; i < n; i++) {
        if (i > 0) {
            putchar(',');                           /*separa <1>*/
            col++;
        }
        if (col+lp >= LIMITE) {                     /*se non ci sta <2>*/
            putchar('\n');
            col = 0;
        }
        printf("%s",par);
        col += lp;
    }
    puts(".");                                      /*<3>*/
}

/*  Note su RipeteParola:
    <1> La virgola separatrice viene stampata prima di ogni parola, tranne
        la prima.
    <2> Se la parola non sta sulla linea corrente entro la colonna LIMITE,
        va a capo.
    <3> puts(".") equivale a: printf(".\n"), in quanto la puts aggiunge
        sempre un newline (\n) dopo la stampa della stringa.
*/
