/*
   Questo programma fa parte del Corso di C
   Copyright (C) 1990 Gruppo Editoriale Jackson
   Copyright (C) 2002 Enrico Colombini
   Tutti i diritti riservati
*/


/* SPECCHIO: inverte l'ordine dei caratteri della frase introdotta */


#include <stdio.h>


int InputFrase(char s[], int lm);       /*prototipi funzioni*/


#define MAXLEN 60               /*lunghezza massima della frase*/


main()
{
    char frase[MAXLEN];         /*spazio per la frase introdotta <1>*/
    int  lf;                    /*lunghezza frase*/
    int  i;

    printf("\n Inversione di una frase:\n\n");

    printf("Cosa ne pensi? ");
    lf = InputFrase(frase,MAXLEN);                  /*legge frase <2>*/

    printf("\nIo credo, al contrario, che ");
    for (i = lf-1; i >= 0; i--) {                   /*stampa a rovescio <3>*/
        putchar(frase[i]);
    }
    printf(".\n");
}

/*  Note su main:
    <1> Questa linea dichiara l'array frase[] di MAXLEN char, numerati da 0
        a MAXLEN-1. Si pu considerare frase[] come una stringa, anche se
        questo programma non termina la stringa con uno zero finale come
        si fa solitamente in C. La lunghezza della stringa, cio il numero
        di elementi di frase[] usati per contenere caratteri,  invece
        conservata separatamente nella variabile lf.
    <2> Come tutti gli array, anche una stringa pu essere passata ad una
        funzione indicandone semplicemente il nome, che  l'indirizzo del
        suo primo elemento (&frase[0]). Dato che la stringa viene passata
        per riferimento (cio per indirizzo), ogni modifica fatta alla
        stringa stessa dalla funzione chiamata ha effetto sulla stringa
        originale passata dal main.
    <3> Una stringa pu essere usata come un normale array. Notare che la
        putchar viene chiamata con un argomento di tipo char (un elemento di
        frase[]), mentre in realt richiede un int: avviene quindi una
        conversione automatica da char ad int, che comunque non causa alcuna
        perdita di informazioni.
*/


/********************************************************************
 * InputFrase: input di una frase nell'array stringa s[], lunghezza
 *             max lm caratteri, ritorna numero caratteri introdotti.
 ********************************************************************/

int InputFrase(char s[], int lm)          /*<1>*/
{
    int nc;     /*numero di caratteri introdotti*/
    int c;

    do {
        nc = 0;
        while ( (c = getchar()) != '\n' && c != EOF && nc < lm) {  /*<2>*/
            s[nc++] = c;                            /*legge stringa <3>*/
        }
        if (nc == 0) {
            printf("Non essere timido, dimmi qualcosa: \a");
        }
    } while (nc == 0);                              /*ripete se non ok*/

    return nc;                                      /*ritorna lunghezza*/
}

/*  Note su InputFrase:
    <1> Il primo argomento indicato  un array di tipo char, del quale
        non si deve specificare la dimensione (in realt quello che viene
        passato  l'indirizzo del suo primo elemento). Ogni modifica fatta
        su questo array  in realt fatta sull'array originario (vedi nota
        2 di main).
    <2> La prima getchar non ritorna finch l'utente non ha battuto Return.
        A questo punto ogni successiva getchar legge un carattere della linea
        introdotta. La lettura termina a fine linea (\n), se  stato premuto
        F6 o Ctrl-Z (EOF), o se si supera il massimo numero di caratteri
        ammessi. Quest'ultimo controllo  molto importante per evitare di
        scrivere oltre la fine dell'array.
    <3> Assegna c all'elemento nc dell'array s[], ed avanza nc all'elemento
        successivo. L'array s[]  quello originario del chiamante, cio in
        questo caso l'array frase[] di main.
*/
