/*
   Questo file fa parte del Corso di C
   Copyright (C) 1990 Gruppo Editoriale Jackson
   Copyright (C) 2002 Enrico Colombini
   Tutti i diritti riservati
*/


// C-CASELL.H: dichiara la classe Casella (per l'uso vedi C-LABIR.CPP)


#ifndef _C_CASELL_H_      //non include due volte
#define _C_CASELL_H_


#include "c-timer.h"      //interfaccia della classe Timer
#include "c-random.h"     //e della classe Random


enum direz { NORD, SUD, EST, OVEST, CENTRO };
enum stati { CREATA, COLLEG, ESPLOR };

#define  MURO   ""    //simbolo per muro
#define  NULLA  "  "    //per passaggio o sfondo
#define  ORMA   ""    //e per esplorazione


/********************************************************************
 * Classe Casella: una casella di 2 x 1 caratteri, circondata da una
 *                 cornice (totale: 6 x 3 caratteri). Pu avere fino
 *                 a 4 collegamenti (Nord, Sud, Est, Ovest).
 ********************************************************************/

class Casella {
protected:                  //<1>
   int x;                   //posizione del simbolo centrale
   int y;
   Casella *adia[4];        //caselle adiacenti N/S/E/W, NULL se nessuna
   Casella *pass[4];        //passaggi N/S/E/W, NULL se chiusi
   int ord[4];              //ordine di esplorazione
   int st;                  //stato della casella

   static int dx[5];        //offset passaggi N/S/E/W/centro <2>
   static int dy[5];
   static int opposta[4];   //direzioni opposte a N/S/E/W
   static Timer ti;         //timer per sincronizzazione
   static Random r;         //per estrazione direzioni a caso

public:
   Casella(int posx, int posy);                       //costruttore
   ~Casella();                                        //distruttore

   void Adiacente(int dir, Casella *c) { adia[dir] = c; };  //adiacenza <3>
   void Collega(int dir)  { pass[dir] = adia[dir]; }; //collegamento <4>
   void Crea();                                       //crea labirinto
   int  Cerca(Casella *c, int rit);                   //lo risolve
   void MetteSimbolo(int dir, char *sim);             //disegna simbolo

protected:
   int  Stato()  { return st; };                      //stato corrente
   int  EstraeDirezione(int n);                       //direzione casuale
};

/* Note sulla classe Casella:
    <1> Vedi nota 1 in C-LABIR.H
    <2> Le variabili statiche di una classe, che esistono in un solo
        esemplare, vanno dichiarate nell'interfaccia (cio qui) e
        definite nell'implementazione (cio in C-CASELL.CPP).
    <3> Registra un pointer alla casella adiacente nella direzione data.
    <4> Apre il passaggio nella direzione indicata, cio scrive in pass[]
        il pointer alla casella adiacente.
*/

#endif
