/*
   Questo file fa parte del Corso di C
   Copyright (C) 1990 Gruppo Editoriale Jackson
   Copyright (C) 2002 Enrico Colombini
   Tutti i diritti riservati
*/


// C-LABIR.H: dichiara la classe Labirinto


#ifndef _C_LABIR_H_       //non include due volte
#define _C_LABIR_H_


#include "c-casell.h"     //interfaccia della classe Casella
#include "c-random.h"     //e della classe Random


#define  MAXH  20         //numero massimo caselle in orizzontale
#define  MAXV  11         //numero massimo caselle in verticale
#define  DISTH 4          //distanza tra le caselle (i muri sono in comune)
#define  DISTV 2


/********************************************************************
 * Classe Labirinto: un labirinto rettangolare di Caselle.
 ********************************************************************/

class Labirinto {
protected:                      //<1>
   int nh;                      //numero di caselle in orizz., verticale
   int nv;
   int h0;                      //posizione casella in alto a sinistra
   int v0;
   Casella *labi[MAXV][MAXH];   //pointer alle caselle del labirinto <2>
   Casella *entrata;            //casella di ingresso
   Casella *uscita;             //casella di uscita
   Random r;                    //per estrazioni casuali <3>

public:
    Labirinto(int numh, int numv, int posh, int posv);  //costruttore
    ~Labirinto();                                       //distruttore <4>

    void Crea()  { entrata->Crea(); };                  //crea labirinto <5>
    void Risolve(int rit);                              //lo risolve

protected:
    void SegnaAdiacenti();                              //e adiacenze
};

/* Note sulla classe Labirinto:
    <1> Usiamo protected invece di private per consentire la creazione di
        classi derivate da questa (vedi E8.22).
    <2> labi[][]  un array di pointer ad oggetti della classe Casella.
    <3> r  un esemplare della classe Random (cio un oggetto), che fa parte
        della classe Labirinto. Questo permette di effettuare estrazioni di
        numeri casuali senza preoccuparsi della relativa inizializzazione.
    <4> La funzione che ha lo stesso nome della classe preceduto da una
        tilde (~)  il distruttore, che viene automaticamente chiamato
        quando un oggetto di questa classe esce dal suo campo di validit.
    <5> Questa semplice funzione inline avvia un procedimento ricorsivo:
        ciascuna casella chiama infatti la stessa funzione delle sue vicine,
        finch il labirinto non  stato completamente creato. Vedi nota 2
        della funzione Risolve nel file C-LABIR.CPP.
*/


#endif