/*
   Questo file fa parte del Corso di C
   Copyright (C) 1990 Gruppo Editoriale Jackson
   Copyright (C) 2002 Enrico Colombini
   Tutti i diritti riservati
*/


// C-RANDOM: funzioni (metodi) della classe Random


#include "c-random.h"    //interfaccia della classe Random

#include <time.h>


//variabili (componenti) statiche della classe Random:

int Random::avviato;                            //generatore avviato <1>


/********************************************************************
 * Funzioni della classe Random
 ********************************************************************/

// costruttore: avvia generatore random, ma solo la prima volta.

Random::Random()
{
    if (! avviato) {                            //avvia se non avviato <2>
        srand((unsigned int)time(NULL));
        avviato = 1;                            //non rifarlo <3>
    }
}

/* Note sulla classe Random:
    <1> Questa variabile  una componente statica della classe Random (anche
        se non si usa la parola static), cio ne esiste una sola per tutti
        gli esemplari della classe. All'inizio contiene zero per definizione.
    <2> La prima volta che un qualsiasi oggetto della classe Random viene
        dichiarato (ed  quindi chiamato questo costruttore), se la variabile
        avviato vale ancora zero significa che  il primo esemplare ad essere
        creato. Viene quindi chiamata la srand per avviare il generatore di
        numeri pseudocasuali.
    <3> Dato che la variabile avviato  comune a tutti gli esemplari, in
        tutte le successive chiamate al costruttore non verr pi eseguita
        alcuna inizializzazione. Questo meccanismo permette di racchiudere
        nella classe Random anche le operazioni di inizializzazione, in modo
        che il programmatore non debba preoccuparsene.
*/
