/*
   Questo file fa parte del Corso di C
   Copyright (C) 1990 Gruppo Editoriale Jackson
   Copyright (C) 2002 Enrico Colombini
   Tutti i diritti riservati
*/


// C-RANDOM.H: dichiara la classe Random


#ifndef _C_RANDOM_H_      //non include due volte
#define _C_RANDOM_H_


#include <stdlib.h>


/********************************************************************
 * Classe Random: numeri pseudocasuali.
 ********************************************************************/

class Random {
private:
    static int avviato;                             //generatore avviato <1>

public:
    Random();                                       //costruttore

    int Rand() { return rand(); };                  //numero casuale <2>
    int RandTra(int min, int max)                   //compreso tra due dati
        { return min+rand()%(max-min+1); };         //<3>
};

/* Note sulla classe Random:
    <1> Questa  una componente statica:  sempre la stessa per tutti gli
        esemplari della classe Random. Deve anche essere dichiarata nella
        implementazione (C-RANDOM.CPP).
    <2> Dato che questa  una funzione inline, non c' alcuna perdita di
        efficienza: una chiamata a Rand viene semplicemente sostituita nel
        testo del programma con una chiamata a rand della libreria standard.
        Il vantaggio di usare una classe invece che chiamare semplicemente
        rand sta nell'inizializzazione automatica, descritta in C-RANDOM.CPP.
    <3> Questa tecnica non  statisticamente molto valida, specie per
        alti valori di (max-min).
*/


#endif
