 /*
   Questo programma fa parte del Corso di C
   Copyright (C) 1990 Gruppo Editoriale Jackson
   Copyright (C) 2002 Enrico Colombini
   Tutti i diritti riservati
*/


// FRAZIONI: operazioni sulle frazioni (oggetti della classe Frazione)


#include "c-fraz.h"         //<1>

#include <iostream.h>       //<2>
#include <strstream.h>      //<3>
#include <string.h>


#define NBUF 80             //lunghezza buffer per input linea


// prototipi funzioni:

int EsegueOperazione(Frazione a, Frazione b, char oper, Frazione& c);

/* Note sulle dichiarazioni:
    <1> Per usare la classe Frazione, occorre includere il corrispondente
        header (interfaccia) C-FRAZ.H e linkare con il codice risultante
        dalla compilazione del sorgente (implementazione) C-FRAZ.CPP.
    <2> La libreria di standard I/O del C  stata sostituita nel C++ con
        una pi completa, versatile, e controllata.
    <3> Quest'altro header serve per usare le funzioni che trattano stringhe
        come fossero file (pi esattamente: stream), funzioni corrispondenti
        alle vecchie sprintf e sscanf.
*/


/********************************************************************
 * main
 ********************************************************************/

main()
{
    cout << "\n- Frazioni in C++, di Enrico Colombini:\n";    //<1>

    char buf[NBUF];
    int  n;
    Frazione a,b;       //operandi                            //<2>
    char oper;          //operatore
    Frazione c;         //risultato

    do {
        cout << "\nScrivi un'operazione tra due frazioni\n"
                "(es. 3/4 - 2/3), o Return per smettere : ";
        
        cin.getline(buf,NBUF);                      //input linea <3>
        n = cin.gcount();                           //caratteri letti <4>

        if (n > 1) {                                //se non nulla
            istrstream in(buf,NBUF);                //legge dal buffer <5>
            in >> a >> oper >> b;                   //input da stream <6>

            if (! in.good()) {                      //controlla <7>
                cout << "\n- Non hai introdotto"
                        " tutti i dati richiesti.\a\n";
            } else if (EsegueOperazione(a,b,oper,c)) {    //esegue <8>
                cout << "\n  " << a                 //mostra risultato <9>
                     << ' ' << oper << ' ' << b
                     << "  fa  " << c << '\n';
            }
        }

    } while (n > 1);                                //esce con Return
}

/*Note su main:
    <1> L'operatore << svolge tutte le funzioni della vecchia printf, e
        chiama automaticamente la funzione adatta al tipo della variabile
        da stampare (in questo caso, char*).
    <2> Avendo incluso lo header C-FRAZ.H che contiene la dichiarazione della
        classe Frazione, possiamo dichiarare oggetti di tipo Frazione come
        se si trattasse di un tipo standard del C. Queste variabili contengono
        sia i dati sia le funzioni che operano su di essi. La dichiarazione
        di un oggetto di tipo Frazione chiama automaticamente il costruttore
        della sua classe, che provvede ad inizializzarlo (vedi C-FRAZ.H).
    <3> cin equivale al vecchio stdin. La funzione getline, che si chiama
        con una sintassi simile a quella delle strutture ( infatti una
        componente del tipo istream, del quale cin  un esemplare), legge
        nell'array indicato una linea terminata dal tasto Return.
    <4> La funzione gcount del tipo istream ritorna il numero di caratteri
        effettivamente letti (qui  contato anche il \n finale).
    <5> Un esemplare della classe istrstream, come quello qui dichiarato (in)
        si una come un istream (es. cin), ma legge invece dalla stringa
        indicata (buf), fino alla lunghezza massima specificata (NBUF).
        Usiamo il vecchio sistema di leggere un'intera stringa, e poi
        estrarne i valori desiderati, per evitare i soliti problemi di
        caratteri avanzati (come con scanf).
    <6> I valori delle variabili a, oper, b sono letti dallo stream in, che
        in realt  una stringa (vedi nota 5). Da notare che a e b sono
        oggetti della classe Frazione, che contengono in s le funzioni per
        essere letti con l'operatore >> come fossero normali variabili.
    <7> La funzione good del tipo istream ritorna vero se  andato tutto bene.
    <8> Nella chiamata alla EsegueOperazione, gli argomenti a, b, oper sono
        passati per valore. L'argomento c  invece passato per riferimento
        ( dichiarato come reference nella funzione e nel relativo prototipo),
        per cui pu essere modificato dalla funzione stessa, che in effetti
        vi scrive il risultato dell'operazione.
    <9> Dato che l'operatore << (stampa in uno stream)  stato ridefinito
        nella classe Frazione, un oggetto di questa classe pu essere
        stampato su cout come ogni altra normale variabile.
*/


/********************************************************************
 * EsegueOperazione: esegue operazione oper tra frazioni a, b, mette
 *                   il risultato in c. Ritorna vero se ok, o stampa
 *                   un messaggio di errore.
 ********************************************************************/

int EsegueOperazione(Frazione a, Frazione b, char oper, Frazione& c)  //<1>
{
    int ok = 0;

    if (a.Num() == 0 || b.Num() == 0) {             //controlla <2>
        cout << "\n- Il numeratore non dev'essere zero.\a\n";
    } else if (a.Den() == 0 || b.Den() == 0) {
        cout << "\n- Il denominatore non dev'essere zero.\a\n";
    } else if (strchr("+-*/",oper) == NULL) {
        cout << "\n- Gli operatori validi sono: + - * /\a\n";
    } else {
        ok = 1;                                     //input valido:

        if (oper == '+') {                          //addizione <3>
            c = a+b;
        } else if (oper == '-') {                   //sottrazione
            c = a-b;
        } else if (oper == '*') {                   //moltiplicazione
            c = a*b;
        } else if (oper == '/') {                   //divisione
            c = a/b;
        }
    }
    return ok;                                      //vero se tutto ok
}

/* Note su EsegueOperazione:
    <1> I primi tre parametri sono ricevuti per valore, ma il quarto (c) 
        una reference: viene ricevuto per riferimento. Ogni modifica alla
        variabile c agisce sull'argomento originale del chiamante (vedi
        nota 8 del main).
    <2> Le funzioni Num e Den della classe Frazione restituiscono
        rispettivamente il valore del numeratore e del denominatore
        dell'oggetto. Non si pu accedere direttamente alle componenti
        della classe, perch altrimenti l'isolamento andrebbe a farsi
        benedire, e si perderebbero tutti i relativi vantaggi.
    <3> Dato che gli operatori +, -, * e / sono ridefiniti nella classe
        Frazione, si possono effettuare le quattro operazioni tra oggetti
        di questa classe come se si trattasse di normali variabili. Tutta
        la complessit di queste operazioni  nascosta all'interno della
        classe stessa.
*/
