 /*
   Questo programma fa parte del Corso di C
   Copyright (C) 1990 Gruppo Editoriale Jackson
   Copyright (C) 2002 Enrico Colombini
   Tutti i diritti riservati
*/


// LABIRINT: disegna labirinti casuali, li risolve


#include "c-labir.h"      //interfaccia della classe Labirinto
#include "c-messag.h"     //della classe Messaggio
#include "c-random.h"     //e della classe Random

#include <conio.h>
#include <string.h>


#define  NH  19           //numero massimo caselle in orizzontale
#define  NV  10           //e verticale
#define  PH  4            //posizione base orizzontale
#define  PV  4            //e verticale

#define  CR  "\r"         //tasti usati (come stringhe, per concatenarli)
#define  SP  " "

#define  RITARDO  3       //ritardo per soluzione al rallentatore


// prototipi funzioni:

int Domanda(char *d, char *validi);
int AspettaTasti(char *validi);


/********************************************************************
 * main
 ********************************************************************/

main()
{
    clrscr();                                       //cancella video
    Messaggio m(1,1,
        "           - Labirinti in C++,"            //mostra titolo <1>
        " di Enrico Colombini e Chiara Tovena -");
    {
        Labirinto a(NH,NV,PH,PV);                   //definisce un labir. <2>
        Domanda(" - Premi Return per"
                " creare un labirinto: ",CR);
        a.Crea();                                   //crea i passaggi <3>

        int c = Domanda(                            //<4>
            " - Premi Return per risolverlo, o"
            " Spazio se lo vuoi al rallentatore: "
            ,CR SP);
        a.Risolve((c == 0) ? 0 : RITARDO);          //risolve labirinto <5>

        Domanda(
            "- Premi Return per cancellare questo"
            " labirinto e crearne due pi piccoli: "
            ,CR);
    }                                               //distrugge labirinto <6>

    {
        Random r;
        int n = r.RandTra(NH/4,NH*3/4);             //estrae suddivisione <7>

        Labirinto a(n-1,NV,PH,PV);                  //definisce due labir. <8>
        Labirinto b(NH-n,NV,PH+DISTH*n,PV);
        a.Crea();                                   //crea i passaggi <9>
        b.Crea();

        int c = Domanda(
            " - Premi Return per risolverli, o"
            " Spazio se li vuoi al rallentatore: "
            ,CR SP);
        a.Risolve((c == 0) ? 0 : RITARDO);          //risolve i labirinti
        b.Risolve((c == 0) ? 0 : RITARDO);

        Domanda(" - Premi Return per terminare"
                " il programma: ",CR);
    }                                               //distrugge labirinti

    gotoxy(1,25);                                   //sistema cursore
}

/* Note su main:
    <1> m  un esemplare della classe Messaggio: il suo costruttore provvede
        a mostrare la stringa su video alla posizione indicata. Il messaggio
        verr tolto automaticamente dal video quando la variabile m uscir
        dal suo campo di validit, cio alla fine del main, e sar di
        conseguenza chiamato il distruttore della classe Messaggio.
    <2> La variabile a  un esemplare della classe Labirinto, il cui
        costruttore disegna una matrice di caselle bianche. Quando la
        variabile a finir la sua esistenza, cio alla graffa chiusa che
        termina il blocco, verr chiamato il corrispondente distruttore (che
        in questo caso cancella il labirinto dal video, oltre a liberare la
        memoria utilizzata).
    <3> La funzione Crea della classe Labirinto provvede a connettere tutte
        le caselle in modo da creare un unico passaggio tra l'entrata e
        l'uscita.
    <4> La funzione Domanda mostra il messaggio passato, ed attende uno dei
        tasti indicati (sono definiti come stringhe, quindi sono concatenati
        in una stringa unica). Ritorna 0 se  premuto il primo, 1 per il
        secondo, eccetera. Notare che in C++ si possono dichiarare variabili
        (es. int c) in qualunque punto le si desideri, non solo all'inizio.
    <5> La funzione Risolve della classe Labirinto cerca una soluzione
        esplorando il labirinto, alla velocit indicata (numero di tick da
        attendere ad ogni passo).
    <6> Questa graffa chiusa termina un blocco (istruzione composta). Tutte
        le variabili dichiarate nel blocco (a, c) vengono distrutte. Se si
        tratta di esemplari di una classe dotata di distruttore (ad esempio,
        a  un Labirinto), esso viene automaticamente chiamato (vedi nota 2).
    <7> r  un esemplare della classe Random, e RandTra  una funzione della
        stessa classe. Il vantaggio di usare una classe , in questo caso,
        che non  necessaria alcuna inizializzazione esplicita del generatore
        di numeri casuali: ci pensa la classe stessa.
    <8> Un grande vantaggio delle classi  la possibilit di creare tanti
        esemplari (oggetti) indipendenti, con la stessa facilit con cui se
        ne crea uno solo. Queste due dichiarazioni creano due labirinti
        del tutto distinti, ciascuno con le sue variabili e (concettualmente)
        con le sue funzioni (in realt le funzioni non vengono duplicate).
    <9> I due oggetti di tipo Labirinto possono essere usati in modo
        indipendente, come se ciascuno fosse l'unico esistente.
*/


/********************************************************************
 * Domanda: mostra domanda d[] sulla linea 25, accetta caratteri
 *          elencati in validi[], ritorna posizione carattere battuto.
 ********************************************************************/

int Domanda(char *d, char *validi)
{
    Messaggio m(1,25,d);                            //mostra domanda <1>
    return AspettaTasti(validi);                    //e aspetta risposta
}

/* Note su Domanda:
    <1> Poich l'oggetto m (che  un esemplare della classe Messaggio)  una
        variabile locale, sparir alla fine della funzione. Sar quindi
        automaticamente chiamato il suo distruttore, che provveder a
        cancellarlo dal video.
*/


/********************************************************************
 * AspettaTasti: pulisce buffer, aspetta uno dei caratteri della
 *               stringa validi[], ritorna posizione nella stringa.
 ********************************************************************/

int AspettaTasti(char *validi)
{
    while(kbhit())  getch();                        //pulisce buffer

    int  c;
    char *p;
    while ( (p = strchr(validi,getch())) == NULL) { //input e cerca
        putch('\a');                                //segnala se non valido
    }

    return p-validi;                                //ritorna posizione
}
