/*
   Questo programma fa parte del Corso di C
   Copyright (C) 1990 Gruppo Editoriale Jackson
   Copyright (C) 2002 Enrico Colombini
   Tutti i diritti riservati
*/


// SCRITTE.CPP: crea e distrugge scritte usando la classe Messaggio


#include "c-messag.h"     //<1>
#include "c-timer.h"

#include "conio.h"        //serve solo per clrscr


main()
{
    clrscr();                                         //pulisce schermo
    Messaggio m1(25,3,"Questa scritta resta ferma."); //crea messaggio <2>

    Timer t;                                          //crea un Timer <3>
    t.Sincro(1.5);                                    //aspetta 1.5 sec <4>

    for (int v = 5; v < 24; v++) {                    //per ogni riga <5>
        Messaggio m2(v*2,v,"Questa invece si muove"); //crea messaggio <6>
        t.Sincro(8);                                  //aspetta <7>
    }                                                 //lo distrugge <8>

}                                                     //distrugge m1 <9>

/* Note su SCRITTE:
    <1> Per usare la classe Messaggio occorre includerne l'interfaccia, cio
        lo header "c-messag.h". La "c-" iniziale  una nostra convenzione
        per indicare che si tratta di una classe. Il codice oggetto ottenuto
        compilando questo programma va linkato con quello di "c-messag.cpp".
        Lo stesso vale per la classe Timer. Dato che le scritte su video sono
        compito della classe Messaggio, non serve includere <iostream.h>.
    <2> L'oggetto m1  un esemplare della classe Messaggio. Il costruttore
        provvede a scrivere la stringa alla posizione indicata. Per alcune
        applicazioni potrebbe essere pi comodo non scrivere subito la
        stringa, ma modificare la classe Messaggio aggiungendo una funzione
        Scrivi (ed una corrispondente Cancella).
    <3> L'oggetto t  un esemplare della classe Timer, che viene qui usato
        per ritardi e sincronizzazioni.
    <4> La funzione Sincro della classe Timer attende il tempo indicato dalla
        chiamata precedente o, in questo caso, dalla creazione dell'oggetto.
        Poich l'argomento  un double, il ritardo  misurato in secondi.
    <5> La variabile v, creata per l'occasione, indica la linea in cui sar
        scritto il successivo messaggio.
    <6> Crea un nuovo esemplare della classe Messaggio, che causer la stampa
        della stringa alla posizione indicata del video.
    <7> Poich l'argomento della Sincro  un int, il ritardo rispetto alla
        precedente chiamata  misurato in tick (8 tick = 0.4 sec circa).
    <8> Dato che l'oggetto m2  stato dichiarato all'interno di un blocco,
        termina la sua esistenza alla parentesi graffa che chiude il blocco.
        Viene quindi chiamato il suo distruttore, che provvede a cancellare
        la scritta dal video (vedi nota 2). Al ciclo successivo, verr creato
        un nuovo oggetto m2 del tutto indipendente dal primo.
    <9> Alla graffa chiusa che termina il main, vengono distrutti tutti gli
        oggetti appartenenti al main stesso, come appunto il Messaggio m1,
        che di conseguenza viene cancellato dal video ad opera del suo
        distruttore.
*/
